/* Assistant.c generated by valac 0.42.5, the Vala compiler
 * generated from Assistant.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 2 -*- */
/*
    This file is part of Déjà Dup.
    For copyright information, see AUTHORS.

    Déjà Dup is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Déjà Dup is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Déjà Dup.  If not, see <http://www.gnu.org/licenses/>.
*/


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include "widgets.h"
#include <glib/gi18n-lib.h>
#include <gobject/gvaluecollector.h>


#define TYPE_ASSISTANT (assistant_get_type ())
#define ASSISTANT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ASSISTANT, Assistant))
#define ASSISTANT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ASSISTANT, AssistantClass))
#define IS_ASSISTANT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ASSISTANT))
#define IS_ASSISTANT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ASSISTANT))
#define ASSISTANT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ASSISTANT, AssistantClass))

typedef struct _Assistant Assistant;
typedef struct _AssistantClass AssistantClass;
typedef struct _AssistantPrivate AssistantPrivate;

#define ASSISTANT_TYPE_PAGE_INFO (assistant_page_info_get_type ())
#define ASSISTANT_PAGE_INFO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ASSISTANT_TYPE_PAGE_INFO, AssistantPageInfo))
#define ASSISTANT_PAGE_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ASSISTANT_TYPE_PAGE_INFO, AssistantPageInfoClass))
#define ASSISTANT_IS_PAGE_INFO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ASSISTANT_TYPE_PAGE_INFO))
#define ASSISTANT_IS_PAGE_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ASSISTANT_TYPE_PAGE_INFO))
#define ASSISTANT_PAGE_INFO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ASSISTANT_TYPE_PAGE_INFO, AssistantPageInfoClass))

typedef struct _AssistantPageInfo AssistantPageInfo;
typedef struct _AssistantPageInfoClass AssistantPageInfoClass;
enum  {
	ASSISTANT_0_PROPERTY,
	ASSISTANT_LAST_OP_WAS_BACK_PROPERTY,
	ASSISTANT_NUM_PROPERTIES
};
static GParamSpec* assistant_properties[ASSISTANT_NUM_PROPERTIES];
typedef enum  {
	ASSISTANT_TYPE_NORMAL,
	ASSISTANT_TYPE_INTERRUPT,
	ASSISTANT_TYPE_CHECK,
	ASSISTANT_TYPE_PROGRESS,
	ASSISTANT_TYPE_FINISH
} AssistantType;


#define ASSISTANT_TYPE_TYPE (assistant_type_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _AssistantPageInfoPrivate AssistantPageInfoPrivate;
typedef struct _Block1Data Block1Data;
#define _assistant_page_info_unref0(var) ((var == NULL) ? NULL : (var = (assistant_page_info_unref (var), NULL)))
typedef struct _AssistantParamSpecPageInfo AssistantParamSpecPageInfo;
enum  {
	ASSISTANT_RESPONSE_SIGNAL,
	ASSISTANT_CANCELED_SIGNAL,
	ASSISTANT_CLOSED_SIGNAL,
	ASSISTANT_RESUMED_SIGNAL,
	ASSISTANT_PREPARE_SIGNAL,
	ASSISTANT_FORWARD_SIGNAL,
	ASSISTANT_BACKWARD_SIGNAL,
	ASSISTANT_NUM_SIGNALS
};
static guint assistant_signals[ASSISTANT_NUM_SIGNALS] = {0};

struct _Assistant {
	GtkWindow parent_instance;
	AssistantPrivate * priv;
	GtkImage* header_icon;
	GtkWidget* forward_button;
	GtkEventBox* page_box;
	gboolean can_resume;
	GList* current;
};

struct _AssistantClass {
	GtkWindowClass parent_class;
};

struct _AssistantPrivate {
	gboolean _last_op_was_back;
	GtkLabel* header_title;
	GtkHeaderBar* header_bar;
	GtkWidget* back_button;
	GtkWidget* cancel_button;
	GtkWidget* close_button;
	GtkWidget* resume_button;
	GtkWidget* apply_button;
	gboolean interrupt_can_continue;
	gboolean interrupted_from_hidden;
	GList* interrupted;
	GList* infos;
	GtkRequisition page_box_req;
};

struct _AssistantPageInfo {
	GTypeInstance parent_instance;
	volatile int ref_count;
	AssistantPageInfoPrivate * priv;
	GtkWidget* page;
	gchar* title;
	AssistantType type;
	gchar* forward_text;
};

struct _AssistantPageInfoClass {
	GTypeClass parent_class;
	void (*finalize) (AssistantPageInfo *self);
};

struct _Block1Data {
	int _ref_count_;
	Assistant* self;
	gint response_id;
};

struct _AssistantParamSpecPageInfo {
	GParamSpec parent_instance;
};


static gint Assistant_private_offset;
static gpointer assistant_parent_class = NULL;
static gpointer assistant_page_info_parent_class = NULL;

GType assistant_get_type (void) G_GNUC_CONST;
gpointer assistant_page_info_ref (gpointer instance);
void assistant_page_info_unref (gpointer instance);
GParamSpec* assistant_param_spec_page_info (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags);
void assistant_value_set_page_info (GValue* value,
                                    gpointer v_object);
void assistant_value_take_page_info (GValue* value,
                                     gpointer v_object);
gpointer assistant_value_get_page_info (const GValue* value);
GType assistant_page_info_get_type (void) G_GNUC_CONST;
GType assistant_type_get_type (void) G_GNUC_CONST;
static void _assistant_page_info_unref0_ (gpointer var);
static inline void _g_list_free__assistant_page_info_unref0_ (GList* self);
#define ASSISTANT_CUSTOM_RESPONSE -1
#define ASSISTANT_APPLY 1
#define ASSISTANT_BACK 2
#define ASSISTANT_FORWARD 3
#define ASSISTANT_CANCEL 4
#define ASSISTANT_CLOSE 5
#define ASSISTANT_RESUME 6
void assistant_allow_forward (Assistant* self,
                              gboolean allow);
void assistant_set_header_icon (Assistant* self,
                                const gchar* name);
static void assistant_handle_response (Assistant* self,
                                gint resp);
void assistant_go_back (Assistant* self);
void assistant_go_forward (Assistant* self);
void assistant_hide_for_now (Assistant* self);
gboolean assistant_is_interrupted (Assistant* self);
void assistant_skip (Assistant* self);
gboolean assistant_get_last_op_was_back (Assistant* self);
static gboolean assistant_is_interrupt_type (AssistantType type);
static void assistant_set_last_op_was_back (Assistant* self,
                                     gboolean value);
static void assistant_page_changed (Assistant* self);
void assistant_go_to_page (Assistant* self,
                           GtkWidget* page);
void assistant_interrupt (Assistant* self,
                          GtkWidget* page,
                          gboolean can_continue,
                          gboolean stay_visible);
static void assistant_use_title (Assistant* self,
                          AssistantPageInfo* info);
static void assistant_set_buttons (Assistant* self);
static void assistant_reset_size (Assistant* self,
                           GtkWidget* page);
GtkButton* assistant_add_button (Assistant* self,
                                 const gchar* label,
                                 gint response_id);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void __lambda4_ (Block1Data* _data1_);
static void ___lambda4__gtk_button_clicked (GtkButton* _sender,
                                     gpointer self);
static void assistant_make_button_default (Assistant* self,
                                    GtkWidget* button);
static gboolean assistant_set_first_page (Assistant* self);
void assistant_append_page (Assistant* self,
                            GtkWidget* page,
                            AssistantType type,
                            const gchar* forward_text);
AssistantPageInfo* assistant_page_info_new (void);
AssistantPageInfo* assistant_page_info_construct (GType object_type);
static gboolean _assistant_set_first_page_gsource_func (gpointer self);
void assistant_set_page_title (Assistant* self,
                               GtkWidget* page,
                               const gchar* title);
Assistant* assistant_construct (GType object_type);
static GObject * assistant_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties);
static void _assistant_handle_response_assistant_response (Assistant* _sender,
                                                    gint response,
                                                    gpointer self);
static void assistant_page_info_finalize (AssistantPageInfo * obj);
static void assistant_finalize (GObject * obj);
static void _vala_assistant_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_assistant_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);


static inline gpointer
assistant_get_instance_private (Assistant* self)
{
	return G_STRUCT_MEMBER_P (self, Assistant_private_offset);
}


GType
assistant_type_get_type (void)
{
	static volatile gsize assistant_type_type_id__volatile = 0;
	if (g_once_init_enter (&assistant_type_type_id__volatile)) {
		static const GEnumValue values[] = {{ASSISTANT_TYPE_NORMAL, "ASSISTANT_TYPE_NORMAL", "normal"}, {ASSISTANT_TYPE_INTERRUPT, "ASSISTANT_TYPE_INTERRUPT", "interrupt"}, {ASSISTANT_TYPE_CHECK, "ASSISTANT_TYPE_CHECK", "check"}, {ASSISTANT_TYPE_PROGRESS, "ASSISTANT_TYPE_PROGRESS", "progress"}, {ASSISTANT_TYPE_FINISH, "ASSISTANT_TYPE_FINISH", "finish"}, {0, NULL, NULL}};
		GType assistant_type_type_id;
		assistant_type_type_id = g_enum_register_static ("AssistantType", values);
		g_once_init_leave (&assistant_type_type_id__volatile, assistant_type_type_id);
	}
	return assistant_type_type_id__volatile;
}


static void
_assistant_page_info_unref0_ (gpointer var)
{
#line 69 "../deja-dup/Assistant.vala"
	(var == NULL) ? NULL : (var = (assistant_page_info_unref (var), NULL));
#line 268 "Assistant.c"
}


static inline void
_g_list_free__assistant_page_info_unref0_ (GList* self)
{
#line 69 "../deja-dup/Assistant.vala"
	g_list_free_full (self, (GDestroyNotify) _assistant_page_info_unref0_);
#line 277 "Assistant.c"
}


void
assistant_allow_forward (Assistant* self,
                         gboolean allow)
{
	gboolean _tmp0_ = FALSE;
	GList* _tmp1_;
#line 112 "../deja-dup/Assistant.vala"
	g_return_if_fail (self != NULL);
#line 114 "../deja-dup/Assistant.vala"
	_tmp1_ = self->current;
#line 114 "../deja-dup/Assistant.vala"
	if (_tmp1_ != NULL) {
#line 293 "Assistant.c"
		GtkWidget* _tmp2_;
#line 114 "../deja-dup/Assistant.vala"
		_tmp2_ = self->forward_button;
#line 114 "../deja-dup/Assistant.vala"
		_tmp0_ = _tmp2_ != NULL;
#line 299 "Assistant.c"
	} else {
#line 114 "../deja-dup/Assistant.vala"
		_tmp0_ = FALSE;
#line 303 "Assistant.c"
	}
#line 114 "../deja-dup/Assistant.vala"
	if (_tmp0_) {
#line 307 "Assistant.c"
		GtkWidget* _tmp3_;
#line 115 "../deja-dup/Assistant.vala"
		_tmp3_ = self->forward_button;
#line 115 "../deja-dup/Assistant.vala"
		gtk_widget_set_sensitive (_tmp3_, allow);
#line 313 "Assistant.c"
	}
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 126 "../deja-dup/Assistant.vala"
	return self ? g_object_ref (self) : NULL;
#line 323 "Assistant.c"
}


void
assistant_set_header_icon (Assistant* self,
                           const gchar* name)
{
	GError * _inner_error_ = NULL;
#line 118 "../deja-dup/Assistant.vala"
	g_return_if_fail (self != NULL);
#line 120 "../deja-dup/Assistant.vala"
	if (name == NULL) {
#line 336 "Assistant.c"
		GtkImage* _tmp0_;
#line 121 "../deja-dup/Assistant.vala"
		_tmp0_ = self->header_icon;
#line 121 "../deja-dup/Assistant.vala"
		g_object_set (_tmp0_, "pixbuf", NULL, NULL);
#line 122 "../deja-dup/Assistant.vala"
		return;
#line 344 "Assistant.c"
	}
	{
		GtkIconTheme* theme = NULL;
		GdkScreen* _tmp1_;
		GtkIconTheme* _tmp2_;
		GtkIconTheme* _tmp3_;
		GdkPixbuf* pixbuf = NULL;
		GtkIconTheme* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		GdkPixbuf* _tmp7_;
		GdkPixbuf* _tmp8_;
		GtkImage* _tmp9_;
		GdkPixbuf* _tmp10_;
#line 126 "../deja-dup/Assistant.vala"
		_tmp1_ = gtk_window_get_screen ((GtkWindow*) self);
#line 126 "../deja-dup/Assistant.vala"
		_tmp2_ = gtk_icon_theme_get_for_screen (_tmp1_);
#line 126 "../deja-dup/Assistant.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 126 "../deja-dup/Assistant.vala"
		theme = _tmp3_;
#line 127 "../deja-dup/Assistant.vala"
		_tmp4_ = theme;
#line 127 "../deja-dup/Assistant.vala"
		_tmp5_ = g_strconcat (name, "-symbolic", NULL);
#line 127 "../deja-dup/Assistant.vala"
		_tmp6_ = _tmp5_;
#line 127 "../deja-dup/Assistant.vala"
		_tmp7_ = gtk_icon_theme_load_icon (_tmp4_, _tmp6_, 48, GTK_ICON_LOOKUP_FORCE_SIZE, &_inner_error_);
#line 127 "../deja-dup/Assistant.vala"
		_tmp8_ = _tmp7_;
#line 127 "../deja-dup/Assistant.vala"
		_g_free0 (_tmp6_);
#line 127 "../deja-dup/Assistant.vala"
		pixbuf = _tmp8_;
#line 127 "../deja-dup/Assistant.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 127 "../deja-dup/Assistant.vala"
			_g_object_unref0 (theme);
#line 385 "Assistant.c"
			goto __catch0_g_error;
		}
#line 129 "../deja-dup/Assistant.vala"
		_tmp9_ = self->header_icon;
#line 129 "../deja-dup/Assistant.vala"
		_tmp10_ = pixbuf;
#line 129 "../deja-dup/Assistant.vala"
		g_object_set (_tmp9_, "pixbuf", _tmp10_, NULL);
#line 125 "../deja-dup/Assistant.vala"
		_g_object_unref0 (pixbuf);
#line 125 "../deja-dup/Assistant.vala"
		_g_object_unref0 (theme);
#line 398 "Assistant.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
#line 125 "../deja-dup/Assistant.vala"
		e = _inner_error_;
#line 125 "../deja-dup/Assistant.vala"
		_inner_error_ = NULL;
#line 125 "../deja-dup/Assistant.vala"
		_g_error_free0 (e);
#line 410 "Assistant.c"
	}
	__finally0:
#line 125 "../deja-dup/Assistant.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 125 "../deja-dup/Assistant.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 125 "../deja-dup/Assistant.vala"
		g_clear_error (&_inner_error_);
#line 125 "../deja-dup/Assistant.vala"
		return;
#line 421 "Assistant.c"
	}
}


static void
assistant_handle_response (Assistant* self,
                           gint resp)
{
#line 136 "../deja-dup/Assistant.vala"
	g_return_if_fail (self != NULL);
#line 138 "../deja-dup/Assistant.vala"
	switch (resp) {
#line 138 "../deja-dup/Assistant.vala"
		case ASSISTANT_BACK:
#line 436 "Assistant.c"
		{
#line 139 "../deja-dup/Assistant.vala"
			assistant_go_back (self);
#line 139 "../deja-dup/Assistant.vala"
			break;
#line 442 "Assistant.c"
		}
#line 138 "../deja-dup/Assistant.vala"
		case ASSISTANT_APPLY:
#line 138 "../deja-dup/Assistant.vala"
		case ASSISTANT_FORWARD:
#line 448 "Assistant.c"
		{
#line 141 "../deja-dup/Assistant.vala"
			assistant_go_forward (self);
#line 141 "../deja-dup/Assistant.vala"
			break;
#line 454 "Assistant.c"
		}
		default:
#line 138 "../deja-dup/Assistant.vala"
		case ASSISTANT_CANCEL:
#line 459 "Assistant.c"
		{
#line 143 "../deja-dup/Assistant.vala"
			g_signal_emit (self, assistant_signals[ASSISTANT_CANCELED_SIGNAL], 0);
#line 143 "../deja-dup/Assistant.vala"
			break;
#line 465 "Assistant.c"
		}
#line 138 "../deja-dup/Assistant.vala"
		case ASSISTANT_CLOSE:
#line 469 "Assistant.c"
		{
#line 144 "../deja-dup/Assistant.vala"
			g_signal_emit (self, assistant_signals[ASSISTANT_CLOSED_SIGNAL], 0);
#line 144 "../deja-dup/Assistant.vala"
			break;
#line 475 "Assistant.c"
		}
#line 138 "../deja-dup/Assistant.vala"
		case ASSISTANT_RESUME:
#line 479 "Assistant.c"
		{
#line 145 "../deja-dup/Assistant.vala"
			g_signal_emit (self, assistant_signals[ASSISTANT_RESUMED_SIGNAL], 0);
#line 145 "../deja-dup/Assistant.vala"
			break;
#line 485 "Assistant.c"
		}
#line 138 "../deja-dup/Assistant.vala"
		case ASSISTANT_CUSTOM_RESPONSE:
#line 489 "Assistant.c"
		{
#line 146 "../deja-dup/Assistant.vala"
			break;
#line 493 "Assistant.c"
		}
	}
}


void
assistant_hide_for_now (Assistant* self)
{
#line 150 "../deja-dup/Assistant.vala"
	g_return_if_fail (self != NULL);
#line 152 "../deja-dup/Assistant.vala"
	deja_dup_hide_background_window_for_shell ((GtkWindow*) self);
#line 506 "Assistant.c"
}


gboolean
assistant_is_interrupted (Assistant* self)
{
	gboolean result = FALSE;
	GList* _tmp0_;
#line 155 "../deja-dup/Assistant.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 157 "../deja-dup/Assistant.vala"
	_tmp0_ = self->priv->interrupted;
#line 157 "../deja-dup/Assistant.vala"
	result = _tmp0_ != NULL;
#line 157 "../deja-dup/Assistant.vala"
	return result;
#line 523 "Assistant.c"
}


void
assistant_skip (Assistant* self)
{
	gboolean _tmp0_;
#line 160 "../deja-dup/Assistant.vala"
	g_return_if_fail (self != NULL);
#line 163 "../deja-dup/Assistant.vala"
	_tmp0_ = self->priv->_last_op_was_back;
#line 163 "../deja-dup/Assistant.vala"
	if (_tmp0_) {
#line 164 "../deja-dup/Assistant.vala"
		assistant_go_back (self);
#line 539 "Assistant.c"
	} else {
#line 166 "../deja-dup/Assistant.vala"
		assistant_go_forward (self);
#line 543 "Assistant.c"
	}
}


static gboolean
assistant_is_interrupt_type (AssistantType type)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 171 "../deja-dup/Assistant.vala"
	if (type == ASSISTANT_TYPE_INTERRUPT) {
#line 171 "../deja-dup/Assistant.vala"
		_tmp0_ = TRUE;
#line 557 "Assistant.c"
	} else {
#line 171 "../deja-dup/Assistant.vala"
		_tmp0_ = type == ASSISTANT_TYPE_CHECK;
#line 561 "Assistant.c"
	}
#line 171 "../deja-dup/Assistant.vala"
	result = _tmp0_;
#line 171 "../deja-dup/Assistant.vala"
	return result;
#line 567 "Assistant.c"
}


void
assistant_go_back (Assistant* self)
{
	GList* next = NULL;
	GList* _tmp0_;
	GList* _tmp12_;
#line 174 "../deja-dup/Assistant.vala"
	g_return_if_fail (self != NULL);
#line 177 "../deja-dup/Assistant.vala"
	_tmp0_ = self->priv->interrupted;
#line 177 "../deja-dup/Assistant.vala"
	if (_tmp0_ != NULL) {
#line 583 "Assistant.c"
		GList* _tmp1_;
		GList* _tmp2_;
#line 178 "../deja-dup/Assistant.vala"
		_tmp1_ = self->priv->interrupted;
#line 178 "../deja-dup/Assistant.vala"
		_tmp2_ = _tmp1_->prev;
#line 178 "../deja-dup/Assistant.vala"
		next = _tmp2_;
#line 592 "Assistant.c"
	} else {
		GList* _tmp3_;
		GList* _tmp4_;
#line 180 "../deja-dup/Assistant.vala"
		_tmp3_ = self->current;
#line 180 "../deja-dup/Assistant.vala"
		_tmp4_ = _tmp3_->prev;
#line 180 "../deja-dup/Assistant.vala"
		next = _tmp4_;
#line 181 "../deja-dup/Assistant.vala"
		while (TRUE) {
#line 604 "Assistant.c"
			gboolean _tmp5_ = FALSE;
			GList* _tmp6_;
			GList* _tmp10_;
			GList* _tmp11_;
#line 181 "../deja-dup/Assistant.vala"
			_tmp6_ = next;
#line 181 "../deja-dup/Assistant.vala"
			if (_tmp6_ != NULL) {
#line 613 "Assistant.c"
				GList* _tmp7_;
				gconstpointer _tmp8_;
				AssistantType _tmp9_;
#line 181 "../deja-dup/Assistant.vala"
				_tmp7_ = next;
#line 181 "../deja-dup/Assistant.vala"
				_tmp8_ = _tmp7_->data;
#line 181 "../deja-dup/Assistant.vala"
				_tmp9_ = ((AssistantPageInfo*) _tmp8_)->type;
#line 181 "../deja-dup/Assistant.vala"
				_tmp5_ = assistant_is_interrupt_type (_tmp9_);
#line 625 "Assistant.c"
			} else {
#line 181 "../deja-dup/Assistant.vala"
				_tmp5_ = FALSE;
#line 629 "Assistant.c"
			}
#line 181 "../deja-dup/Assistant.vala"
			if (!_tmp5_) {
#line 181 "../deja-dup/Assistant.vala"
				break;
#line 635 "Assistant.c"
			}
#line 182 "../deja-dup/Assistant.vala"
			_tmp10_ = next;
#line 182 "../deja-dup/Assistant.vala"
			_tmp11_ = _tmp10_->prev;
#line 182 "../deja-dup/Assistant.vala"
			next = _tmp11_;
#line 643 "Assistant.c"
		}
	}
#line 185 "../deja-dup/Assistant.vala"
	_tmp12_ = next;
#line 185 "../deja-dup/Assistant.vala"
	if (_tmp12_ != NULL) {
#line 650 "Assistant.c"
		GList* _tmp13_;
#line 186 "../deja-dup/Assistant.vala"
		assistant_set_last_op_was_back (self, TRUE);
#line 187 "../deja-dup/Assistant.vala"
		_tmp13_ = next;
#line 187 "../deja-dup/Assistant.vala"
		self->current = _tmp13_;
#line 188 "../deja-dup/Assistant.vala"
		assistant_page_changed (self);
#line 189 "../deja-dup/Assistant.vala"
		g_signal_emit (self, assistant_signals[ASSISTANT_BACKWARD_SIGNAL], 0);
#line 662 "Assistant.c"
	}
}


void
assistant_go_forward (Assistant* self)
{
	GList* next = NULL;
	GList* _tmp0_;
	GList* _tmp15_;
#line 193 "../deja-dup/Assistant.vala"
	g_return_if_fail (self != NULL);
#line 196 "../deja-dup/Assistant.vala"
	_tmp0_ = self->priv->interrupted;
#line 196 "../deja-dup/Assistant.vala"
	if (_tmp0_ != NULL) {
#line 679 "Assistant.c"
		GList* _tmp1_;
		gboolean _tmp2_;
#line 197 "../deja-dup/Assistant.vala"
		_tmp1_ = self->priv->interrupted;
#line 197 "../deja-dup/Assistant.vala"
		next = _tmp1_;
#line 198 "../deja-dup/Assistant.vala"
		_tmp2_ = self->priv->interrupted_from_hidden;
#line 198 "../deja-dup/Assistant.vala"
		if (_tmp2_) {
#line 199 "../deja-dup/Assistant.vala"
			assistant_hide_for_now (self);
#line 692 "Assistant.c"
		}
	} else {
		GList* _tmp3_ = NULL;
		GList* _tmp4_;
#line 202 "../deja-dup/Assistant.vala"
		_tmp4_ = self->current;
#line 202 "../deja-dup/Assistant.vala"
		if (_tmp4_ == NULL) {
#line 701 "Assistant.c"
			GList* _tmp5_;
#line 202 "../deja-dup/Assistant.vala"
			_tmp5_ = self->priv->infos;
#line 202 "../deja-dup/Assistant.vala"
			_tmp3_ = _tmp5_;
#line 707 "Assistant.c"
		} else {
			GList* _tmp6_;
			GList* _tmp7_;
#line 202 "../deja-dup/Assistant.vala"
			_tmp6_ = self->current;
#line 202 "../deja-dup/Assistant.vala"
			_tmp7_ = _tmp6_->next;
#line 202 "../deja-dup/Assistant.vala"
			_tmp3_ = _tmp7_;
#line 717 "Assistant.c"
		}
#line 202 "../deja-dup/Assistant.vala"
		next = _tmp3_;
#line 203 "../deja-dup/Assistant.vala"
		while (TRUE) {
#line 723 "Assistant.c"
			gboolean _tmp8_ = FALSE;
			GList* _tmp9_;
			GList* _tmp13_;
			GList* _tmp14_;
#line 203 "../deja-dup/Assistant.vala"
			_tmp9_ = next;
#line 203 "../deja-dup/Assistant.vala"
			if (_tmp9_ != NULL) {
#line 732 "Assistant.c"
				GList* _tmp10_;
				gconstpointer _tmp11_;
				AssistantType _tmp12_;
#line 203 "../deja-dup/Assistant.vala"
				_tmp10_ = next;
#line 203 "../deja-dup/Assistant.vala"
				_tmp11_ = _tmp10_->data;
#line 203 "../deja-dup/Assistant.vala"
				_tmp12_ = ((AssistantPageInfo*) _tmp11_)->type;
#line 203 "../deja-dup/Assistant.vala"
				_tmp8_ = assistant_is_interrupt_type (_tmp12_);
#line 744 "Assistant.c"
			} else {
#line 203 "../deja-dup/Assistant.vala"
				_tmp8_ = FALSE;
#line 748 "Assistant.c"
			}
#line 203 "../deja-dup/Assistant.vala"
			if (!_tmp8_) {
#line 203 "../deja-dup/Assistant.vala"
				break;
#line 754 "Assistant.c"
			}
#line 204 "../deja-dup/Assistant.vala"
			_tmp13_ = next;
#line 204 "../deja-dup/Assistant.vala"
			_tmp14_ = _tmp13_->next;
#line 204 "../deja-dup/Assistant.vala"
			next = _tmp14_;
#line 762 "Assistant.c"
		}
	}
#line 207 "../deja-dup/Assistant.vala"
	_tmp15_ = next;
#line 207 "../deja-dup/Assistant.vala"
	if (_tmp15_ != NULL) {
#line 769 "Assistant.c"
		GList* _tmp16_;
#line 208 "../deja-dup/Assistant.vala"
		assistant_set_last_op_was_back (self, FALSE);
#line 209 "../deja-dup/Assistant.vala"
		_tmp16_ = next;
#line 209 "../deja-dup/Assistant.vala"
		self->current = _tmp16_;
#line 210 "../deja-dup/Assistant.vala"
		assistant_page_changed (self);
#line 211 "../deja-dup/Assistant.vala"
		g_signal_emit (self, assistant_signals[ASSISTANT_FORWARD_SIGNAL], 0);
#line 781 "Assistant.c"
	}
}


void
assistant_go_to_page (Assistant* self,
                      GtkWidget* page)
{
	GList* i = NULL;
	GList* _tmp0_;
#line 215 "../deja-dup/Assistant.vala"
	g_return_if_fail (self != NULL);
#line 215 "../deja-dup/Assistant.vala"
	g_return_if_fail (page != NULL);
#line 217 "../deja-dup/Assistant.vala"
	_tmp0_ = self->priv->infos;
#line 217 "../deja-dup/Assistant.vala"
	i = _tmp0_;
#line 218 "../deja-dup/Assistant.vala"
	while (TRUE) {
#line 802 "Assistant.c"
		GList* _tmp1_;
		GList* _tmp2_;
		gconstpointer _tmp3_;
		GtkWidget* _tmp4_;
		GList* _tmp6_;
		GList* _tmp7_;
#line 218 "../deja-dup/Assistant.vala"
		_tmp1_ = i;
#line 218 "../deja-dup/Assistant.vala"
		if (!(_tmp1_ != NULL)) {
#line 218 "../deja-dup/Assistant.vala"
			break;
#line 815 "Assistant.c"
		}
#line 219 "../deja-dup/Assistant.vala"
		_tmp2_ = i;
#line 219 "../deja-dup/Assistant.vala"
		_tmp3_ = _tmp2_->data;
#line 219 "../deja-dup/Assistant.vala"
		_tmp4_ = ((AssistantPageInfo*) _tmp3_)->page;
#line 219 "../deja-dup/Assistant.vala"
		if (_tmp4_ == page) {
#line 825 "Assistant.c"
			GList* _tmp5_;
#line 220 "../deja-dup/Assistant.vala"
			_tmp5_ = i;
#line 220 "../deja-dup/Assistant.vala"
			self->current = _tmp5_;
#line 221 "../deja-dup/Assistant.vala"
			assistant_page_changed (self);
#line 222 "../deja-dup/Assistant.vala"
			break;
#line 835 "Assistant.c"
		}
#line 224 "../deja-dup/Assistant.vala"
		_tmp6_ = i;
#line 224 "../deja-dup/Assistant.vala"
		_tmp7_ = _tmp6_->next;
#line 224 "../deja-dup/Assistant.vala"
		i = _tmp7_;
#line 843 "Assistant.c"
	}
}


void
assistant_interrupt (Assistant* self,
                     GtkWidget* page,
                     gboolean can_continue,
                     gboolean stay_visible)
{
	GList* was = NULL;
	GList* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GList* _tmp4_;
#line 228 "../deja-dup/Assistant.vala"
	g_return_if_fail (self != NULL);
#line 228 "../deja-dup/Assistant.vala"
	g_return_if_fail (page != NULL);
#line 230 "../deja-dup/Assistant.vala"
	_tmp0_ = self->current;
#line 230 "../deja-dup/Assistant.vala"
	was = _tmp0_;
#line 231 "../deja-dup/Assistant.vala"
	self->priv->interrupt_can_continue = can_continue;
#line 232 "../deja-dup/Assistant.vala"
	assistant_go_to_page (self, page);
#line 233 "../deja-dup/Assistant.vala"
	_tmp2_ = gtk_widget_get_visible ((GtkWidget*) self);
#line 233 "../deja-dup/Assistant.vala"
	_tmp3_ = _tmp2_;
#line 233 "../deja-dup/Assistant.vala"
	if (!_tmp3_) {
#line 233 "../deja-dup/Assistant.vala"
		_tmp1_ = !stay_visible;
#line 880 "Assistant.c"
	} else {
#line 233 "../deja-dup/Assistant.vala"
		_tmp1_ = FALSE;
#line 884 "Assistant.c"
	}
#line 233 "../deja-dup/Assistant.vala"
	if (_tmp1_) {
#line 234 "../deja-dup/Assistant.vala"
		self->priv->interrupted_from_hidden = TRUE;
#line 890 "Assistant.c"
	}
#line 236 "../deja-dup/Assistant.vala"
	_tmp4_ = was;
#line 236 "../deja-dup/Assistant.vala"
	self->priv->interrupted = _tmp4_;
#line 896 "Assistant.c"
}


static void
assistant_use_title (Assistant* self,
                     AssistantPageInfo* info)
{
	gchar* title = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GtkLabel* _tmp2_;
#line 239 "../deja-dup/Assistant.vala"
	g_return_if_fail (self != NULL);
#line 239 "../deja-dup/Assistant.vala"
	g_return_if_fail (info != NULL);
#line 241 "../deja-dup/Assistant.vala"
	_tmp0_ = info->title;
#line 241 "../deja-dup/Assistant.vala"
	_tmp1_ = g_markup_printf_escaped ("<span size=\"xx-large\" weight=\"ultrabold\">%s</span>", _tmp0_);
#line 241 "../deja-dup/Assistant.vala"
	title = _tmp1_;
#line 242 "../deja-dup/Assistant.vala"
	_tmp2_ = self->priv->header_title;
#line 242 "../deja-dup/Assistant.vala"
	gtk_label_set_markup (_tmp2_, title);
#line 239 "../deja-dup/Assistant.vala"
	_g_free0 (title);
#line 924 "Assistant.c"
}


static void
assistant_page_changed (Assistant* self)
{
	GList* _tmp0_;
	AssistantPageInfo* info = NULL;
	GList* _tmp1_;
	gconstpointer _tmp2_;
	AssistantPageInfo* _tmp3_;
	GtkWidget* _tmp4_;
	GList* _tmp5_;
	gconstpointer _tmp6_;
	GtkWidget* _tmp7_;
	AssistantPageInfo* _tmp8_;
	GtkWidget* _tmp9_;
#line 245 "../deja-dup/Assistant.vala"
	g_return_if_fail (self != NULL);
#line 247 "../deja-dup/Assistant.vala"
	_tmp0_ = self->current;
#line 247 "../deja-dup/Assistant.vala"
	g_return_if_fail (_tmp0_ != NULL);
#line 249 "../deja-dup/Assistant.vala"
	self->priv->interrupted = NULL;
#line 250 "../deja-dup/Assistant.vala"
	self->priv->interrupted_from_hidden = FALSE;
#line 251 "../deja-dup/Assistant.vala"
	_tmp1_ = self->current;
#line 251 "../deja-dup/Assistant.vala"
	_tmp2_ = _tmp1_->data;
#line 251 "../deja-dup/Assistant.vala"
	info = (AssistantPageInfo*) _tmp2_;
#line 253 "../deja-dup/Assistant.vala"
	assistant_set_header_icon (self, NULL);
#line 255 "../deja-dup/Assistant.vala"
	_tmp3_ = info;
#line 255 "../deja-dup/Assistant.vala"
	_tmp4_ = _tmp3_->page;
#line 255 "../deja-dup/Assistant.vala"
	g_signal_emit (self, assistant_signals[ASSISTANT_PREPARE_SIGNAL], 0, _tmp4_);
#line 259 "../deja-dup/Assistant.vala"
	_tmp5_ = self->current;
#line 259 "../deja-dup/Assistant.vala"
	_tmp6_ = _tmp5_->data;
#line 259 "../deja-dup/Assistant.vala"
	_tmp7_ = ((AssistantPageInfo*) _tmp6_)->page;
#line 259 "../deja-dup/Assistant.vala"
	_tmp8_ = info;
#line 259 "../deja-dup/Assistant.vala"
	_tmp9_ = _tmp8_->page;
#line 259 "../deja-dup/Assistant.vala"
	if (_tmp7_ == _tmp9_) {
#line 978 "Assistant.c"
		AssistantPageInfo* _tmp10_;
		GtkWidget* child = NULL;
		GtkEventBox* _tmp11_;
		GtkWidget* _tmp12_;
		GtkWidget* _tmp13_;
		GtkWidget* _tmp14_;
		GtkEventBox* _tmp18_;
		AssistantPageInfo* _tmp19_;
		GtkWidget* _tmp20_;
		AssistantPageInfo* _tmp21_;
		GtkWidget* _tmp22_;
		AssistantPageInfo* _tmp23_;
		GtkWidget* _tmp24_;
		GtkWidget* w = NULL;
		GtkWidget* _tmp25_;
		GtkWidget* _tmp26_;
		gboolean _tmp27_ = FALSE;
		GtkWidget* _tmp28_;
#line 260 "../deja-dup/Assistant.vala"
		_tmp10_ = info;
#line 260 "../deja-dup/Assistant.vala"
		assistant_use_title (self, _tmp10_);
#line 261 "../deja-dup/Assistant.vala"
		assistant_set_buttons (self);
#line 263 "../deja-dup/Assistant.vala"
		_tmp11_ = self->page_box;
#line 263 "../deja-dup/Assistant.vala"
		_tmp12_ = gtk_bin_get_child ((GtkBin*) _tmp11_);
#line 263 "../deja-dup/Assistant.vala"
		_tmp13_ = _g_object_ref0 (_tmp12_);
#line 263 "../deja-dup/Assistant.vala"
		child = _tmp13_;
#line 264 "../deja-dup/Assistant.vala"
		_tmp14_ = child;
#line 264 "../deja-dup/Assistant.vala"
		if (_tmp14_ != NULL) {
#line 1015 "Assistant.c"
			GtkWidget* _tmp15_;
			GtkEventBox* _tmp16_;
			GtkWidget* _tmp17_;
#line 265 "../deja-dup/Assistant.vala"
			_tmp15_ = child;
#line 265 "../deja-dup/Assistant.vala"
			gtk_widget_hide (_tmp15_);
#line 266 "../deja-dup/Assistant.vala"
			_tmp16_ = self->page_box;
#line 266 "../deja-dup/Assistant.vala"
			_tmp17_ = child;
#line 266 "../deja-dup/Assistant.vala"
			gtk_container_remove ((GtkContainer*) _tmp16_, _tmp17_);
#line 1029 "Assistant.c"
		}
#line 268 "../deja-dup/Assistant.vala"
		_tmp18_ = self->page_box;
#line 268 "../deja-dup/Assistant.vala"
		_tmp19_ = info;
#line 268 "../deja-dup/Assistant.vala"
		_tmp20_ = _tmp19_->page;
#line 268 "../deja-dup/Assistant.vala"
		gtk_container_add ((GtkContainer*) _tmp18_, _tmp20_);
#line 269 "../deja-dup/Assistant.vala"
		_tmp21_ = info;
#line 269 "../deja-dup/Assistant.vala"
		_tmp22_ = _tmp21_->page;
#line 269 "../deja-dup/Assistant.vala"
		gtk_widget_show (_tmp22_);
#line 271 "../deja-dup/Assistant.vala"
		_tmp23_ = info;
#line 271 "../deja-dup/Assistant.vala"
		_tmp24_ = _tmp23_->page;
#line 271 "../deja-dup/Assistant.vala"
		assistant_reset_size (self, _tmp24_);
#line 273 "../deja-dup/Assistant.vala"
		_tmp25_ = gtk_window_get_focus ((GtkWindow*) self);
#line 273 "../deja-dup/Assistant.vala"
		_tmp26_ = _g_object_ref0 (_tmp25_);
#line 273 "../deja-dup/Assistant.vala"
		w = _tmp26_;
#line 274 "../deja-dup/Assistant.vala"
		_tmp28_ = w;
#line 274 "../deja-dup/Assistant.vala"
		if (_tmp28_ != NULL) {
#line 1061 "Assistant.c"
			GtkWidget* _tmp29_;
#line 274 "../deja-dup/Assistant.vala"
			_tmp29_ = w;
#line 274 "../deja-dup/Assistant.vala"
			_tmp27_ = G_TYPE_FROM_INSTANCE ((GObject*) _tmp29_) == gtk_label_get_type ();
#line 1067 "Assistant.c"
		} else {
#line 274 "../deja-dup/Assistant.vala"
			_tmp27_ = FALSE;
#line 1071 "Assistant.c"
		}
#line 274 "../deja-dup/Assistant.vala"
		if (_tmp27_) {
#line 1075 "Assistant.c"
			GtkWidget* _tmp30_;
#line 275 "../deja-dup/Assistant.vala"
			_tmp30_ = w;
#line 275 "../deja-dup/Assistant.vala"
			gtk_label_select_region (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, gtk_label_get_type (), GtkLabel), -1, -1);
#line 1081 "Assistant.c"
		}
#line 259 "../deja-dup/Assistant.vala"
		_g_object_unref0 (w);
#line 259 "../deja-dup/Assistant.vala"
		_g_object_unref0 (child);
#line 1087 "Assistant.c"
	}
}


static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 279 "../deja-dup/Assistant.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 279 "../deja-dup/Assistant.vala"
	return _data1_;
#line 1099 "Assistant.c"
}


static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 279 "../deja-dup/Assistant.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 1110 "Assistant.c"
		Assistant* self;
#line 279 "../deja-dup/Assistant.vala"
		self = _data1_->self;
#line 279 "../deja-dup/Assistant.vala"
		_g_object_unref0 (self);
#line 279 "../deja-dup/Assistant.vala"
		g_slice_free (Block1Data, _data1_);
#line 1118 "Assistant.c"
	}
}


static void
__lambda4_ (Block1Data* _data1_)
{
	Assistant* self;
#line 283 "../deja-dup/Assistant.vala"
	self = _data1_->self;
#line 283 "../deja-dup/Assistant.vala"
	g_signal_emit (self, assistant_signals[ASSISTANT_RESPONSE_SIGNAL], 0, _data1_->response_id);
#line 1131 "Assistant.c"
}


static void
___lambda4__gtk_button_clicked (GtkButton* _sender,
                                gpointer self)
{
#line 283 "../deja-dup/Assistant.vala"
	__lambda4_ (self);
#line 1141 "Assistant.c"
}


GtkButton*
assistant_add_button (Assistant* self,
                      const gchar* label,
                      gint response_id)
{
	GtkButton* result = NULL;
	Block1Data* _data1_;
	GtkButton* btn = NULL;
	GtkButton* _tmp0_;
	GtkButton* _tmp1_;
	GtkButton* _tmp2_;
	GtkButton* _tmp3_;
#line 279 "../deja-dup/Assistant.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 279 "../deja-dup/Assistant.vala"
	g_return_val_if_fail (label != NULL, NULL);
#line 279 "../deja-dup/Assistant.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 279 "../deja-dup/Assistant.vala"
	_data1_->_ref_count_ = 1;
#line 279 "../deja-dup/Assistant.vala"
	_data1_->self = g_object_ref (self);
#line 279 "../deja-dup/Assistant.vala"
	_data1_->response_id = response_id;
#line 281 "../deja-dup/Assistant.vala"
	_tmp0_ = (GtkButton*) gtk_button_new_with_mnemonic (label);
#line 281 "../deja-dup/Assistant.vala"
	g_object_ref_sink (_tmp0_);
#line 281 "../deja-dup/Assistant.vala"
	btn = _tmp0_;
#line 282 "../deja-dup/Assistant.vala"
	_tmp1_ = btn;
#line 282 "../deja-dup/Assistant.vala"
	gtk_widget_set_can_default ((GtkWidget*) _tmp1_, TRUE);
#line 283 "../deja-dup/Assistant.vala"
	_tmp2_ = btn;
#line 283 "../deja-dup/Assistant.vala"
	g_signal_connect_data (_tmp2_, "clicked", (GCallback) ___lambda4__gtk_button_clicked, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
#line 284 "../deja-dup/Assistant.vala"
	_tmp3_ = btn;
#line 284 "../deja-dup/Assistant.vala"
	gtk_widget_show ((GtkWidget*) _tmp3_);
#line 285 "../deja-dup/Assistant.vala"
	if (_data1_->response_id == ASSISTANT_CANCEL) {
#line 1189 "Assistant.c"
		GtkHeaderBar* _tmp4_;
		GtkButton* _tmp5_;
#line 286 "../deja-dup/Assistant.vala"
		_tmp4_ = self->priv->header_bar;
#line 286 "../deja-dup/Assistant.vala"
		_tmp5_ = btn;
#line 286 "../deja-dup/Assistant.vala"
		gtk_header_bar_pack_start (_tmp4_, (GtkWidget*) _tmp5_);
#line 1198 "Assistant.c"
	} else {
		GtkHeaderBar* _tmp6_;
		GtkButton* _tmp7_;
#line 288 "../deja-dup/Assistant.vala"
		_tmp6_ = self->priv->header_bar;
#line 288 "../deja-dup/Assistant.vala"
		_tmp7_ = btn;
#line 288 "../deja-dup/Assistant.vala"
		gtk_header_bar_pack_end (_tmp6_, (GtkWidget*) _tmp7_);
#line 1208 "Assistant.c"
	}
#line 289 "../deja-dup/Assistant.vala"
	result = btn;
#line 289 "../deja-dup/Assistant.vala"
	block1_data_unref (_data1_);
#line 289 "../deja-dup/Assistant.vala"
	_data1_ = NULL;
#line 289 "../deja-dup/Assistant.vala"
	return result;
#line 1218 "Assistant.c"
}


static void
assistant_make_button_default (Assistant* self,
                               GtkWidget* button)
{
	GtkStyleContext* _tmp0_;
#line 292 "../deja-dup/Assistant.vala"
	g_return_if_fail (self != NULL);
#line 292 "../deja-dup/Assistant.vala"
	g_return_if_fail (button != NULL);
#line 294 "../deja-dup/Assistant.vala"
	gtk_widget_grab_default (button);
#line 295 "../deja-dup/Assistant.vala"
	_tmp0_ = gtk_widget_get_style_context (button);
#line 295 "../deja-dup/Assistant.vala"
	gtk_style_context_add_class (_tmp0_, GTK_STYLE_CLASS_SUGGESTED_ACTION);
#line 1237 "Assistant.c"
}


static void
assistant_set_buttons (Assistant* self)
{
	GList* _tmp0_;
	AssistantPageInfo* info = NULL;
	GList* _tmp1_;
	gconstpointer _tmp2_;
	gboolean show_cancel = FALSE;
	gboolean show_back = FALSE;
	gboolean show_forward = FALSE;
	gboolean show_close = FALSE;
	gboolean show_resume = FALSE;
	gboolean has_default = FALSE;
	gchar* forward_text = NULL;
	AssistantPageInfo* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	AssistantPageInfo* _tmp6_;
	AssistantType _tmp7_;
	GtkHeaderBar* area = NULL;
	GtkHeaderBar* _tmp14_;
	GtkHeaderBar* _tmp15_;
	GtkWidget* _tmp16_;
	GtkWidget* _tmp20_;
	GtkWidget* _tmp24_;
	GtkWidget* _tmp28_;
	GtkWidget* _tmp32_;
	GtkWidget* _tmp36_;
	gboolean _tmp40_;
	gboolean _tmp46_;
	gboolean _tmp50_;
	gboolean _tmp52_;
	gboolean _tmp56_;
#line 298 "../deja-dup/Assistant.vala"
	g_return_if_fail (self != NULL);
#line 300 "../deja-dup/Assistant.vala"
	_tmp0_ = self->current;
#line 300 "../deja-dup/Assistant.vala"
	g_return_if_fail (_tmp0_ != NULL);
#line 302 "../deja-dup/Assistant.vala"
	_tmp1_ = self->current;
#line 302 "../deja-dup/Assistant.vala"
	_tmp2_ = _tmp1_->data;
#line 302 "../deja-dup/Assistant.vala"
	info = (AssistantPageInfo*) _tmp2_;
#line 304 "../deja-dup/Assistant.vala"
	show_cancel = FALSE;
#line 304 "../deja-dup/Assistant.vala"
	show_back = FALSE;
#line 304 "../deja-dup/Assistant.vala"
	show_forward = FALSE;
#line 305 "../deja-dup/Assistant.vala"
	show_close = FALSE;
#line 305 "../deja-dup/Assistant.vala"
	show_resume = FALSE;
#line 306 "../deja-dup/Assistant.vala"
	has_default = FALSE;
#line 307 "../deja-dup/Assistant.vala"
	_tmp3_ = info;
#line 307 "../deja-dup/Assistant.vala"
	_tmp4_ = _tmp3_->forward_text;
#line 307 "../deja-dup/Assistant.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 307 "../deja-dup/Assistant.vala"
	forward_text = _tmp5_;
#line 309 "../deja-dup/Assistant.vala"
	_tmp6_ = info;
#line 309 "../deja-dup/Assistant.vala"
	_tmp7_ = _tmp6_->type;
#line 309 "../deja-dup/Assistant.vala"
	switch (_tmp7_) {
#line 1312 "Assistant.c"
		default:
#line 309 "../deja-dup/Assistant.vala"
		case ASSISTANT_TYPE_NORMAL:
#line 1316 "Assistant.c"
		{
			GList* _tmp8_;
			GList* _tmp9_;
#line 312 "../deja-dup/Assistant.vala"
			show_cancel = TRUE;
#line 313 "../deja-dup/Assistant.vala"
			_tmp8_ = self->current;
#line 313 "../deja-dup/Assistant.vala"
			_tmp9_ = _tmp8_->prev;
#line 313 "../deja-dup/Assistant.vala"
			show_back = _tmp9_ != NULL;
#line 314 "../deja-dup/Assistant.vala"
			show_forward = TRUE;
#line 315 "../deja-dup/Assistant.vala"
			break;
#line 1332 "Assistant.c"
		}
#line 309 "../deja-dup/Assistant.vala"
		case ASSISTANT_TYPE_INTERRUPT:
#line 1336 "Assistant.c"
		{
			gboolean _tmp10_;
#line 317 "../deja-dup/Assistant.vala"
			show_cancel = TRUE;
#line 318 "../deja-dup/Assistant.vala"
			_tmp10_ = self->priv->interrupt_can_continue;
#line 318 "../deja-dup/Assistant.vala"
			if (_tmp10_) {
#line 1345 "Assistant.c"
				gchar* _tmp11_;
#line 319 "../deja-dup/Assistant.vala"
				show_forward = TRUE;
#line 320 "../deja-dup/Assistant.vala"
				_tmp11_ = g_strdup (_ ("Co_ntinue"));
#line 320 "../deja-dup/Assistant.vala"
				_g_free0 (forward_text);
#line 320 "../deja-dup/Assistant.vala"
				forward_text = _tmp11_;
#line 1355 "Assistant.c"
			}
#line 322 "../deja-dup/Assistant.vala"
			break;
#line 1359 "Assistant.c"
		}
#line 309 "../deja-dup/Assistant.vala"
		case ASSISTANT_TYPE_CHECK:
#line 1363 "Assistant.c"
		{
			gchar* _tmp12_;
#line 324 "../deja-dup/Assistant.vala"
			show_close = TRUE;
#line 325 "../deja-dup/Assistant.vala"
			show_forward = TRUE;
#line 326 "../deja-dup/Assistant.vala"
			_tmp12_ = g_strdup (C_ ("verb", "_Test"));
#line 326 "../deja-dup/Assistant.vala"
			_g_free0 (forward_text);
#line 326 "../deja-dup/Assistant.vala"
			forward_text = _tmp12_;
#line 327 "../deja-dup/Assistant.vala"
			break;
#line 1378 "Assistant.c"
		}
#line 309 "../deja-dup/Assistant.vala"
		case ASSISTANT_TYPE_PROGRESS:
#line 1382 "Assistant.c"
		{
			gboolean _tmp13_;
#line 329 "../deja-dup/Assistant.vala"
			show_cancel = TRUE;
#line 330 "../deja-dup/Assistant.vala"
			_tmp13_ = self->can_resume;
#line 330 "../deja-dup/Assistant.vala"
			if (_tmp13_) {
#line 331 "../deja-dup/Assistant.vala"
				show_resume = TRUE;
#line 1393 "Assistant.c"
			}
#line 332 "../deja-dup/Assistant.vala"
			break;
#line 1397 "Assistant.c"
		}
#line 309 "../deja-dup/Assistant.vala"
		case ASSISTANT_TYPE_FINISH:
#line 1401 "Assistant.c"
		{
#line 334 "../deja-dup/Assistant.vala"
			show_close = TRUE;
#line 335 "../deja-dup/Assistant.vala"
			break;
#line 1407 "Assistant.c"
		}
	}
#line 341 "../deja-dup/Assistant.vala"
	_tmp14_ = self->priv->header_bar;
#line 341 "../deja-dup/Assistant.vala"
	_tmp15_ = _g_object_ref0 (_tmp14_);
#line 341 "../deja-dup/Assistant.vala"
	area = _tmp15_;
#line 342 "../deja-dup/Assistant.vala"
	_tmp16_ = self->priv->cancel_button;
#line 342 "../deja-dup/Assistant.vala"
	if (_tmp16_ != NULL) {
#line 1420 "Assistant.c"
		GtkHeaderBar* _tmp17_;
		GtkWidget* _tmp18_;
		GtkWidget* _tmp19_;
#line 343 "../deja-dup/Assistant.vala"
		_tmp17_ = area;
#line 343 "../deja-dup/Assistant.vala"
		_tmp18_ = self->priv->cancel_button;
#line 343 "../deja-dup/Assistant.vala"
		gtk_container_remove ((GtkContainer*) _tmp17_, _tmp18_);
#line 343 "../deja-dup/Assistant.vala"
		_tmp19_ = self->priv->cancel_button;
#line 343 "../deja-dup/Assistant.vala"
		deja_dup_destroy_widget (_tmp19_);
#line 343 "../deja-dup/Assistant.vala"
		_g_object_unref0 (self->priv->cancel_button);
#line 343 "../deja-dup/Assistant.vala"
		self->priv->cancel_button = NULL;
#line 1438 "Assistant.c"
	}
#line 344 "../deja-dup/Assistant.vala"
	_tmp20_ = self->priv->close_button;
#line 344 "../deja-dup/Assistant.vala"
	if (_tmp20_ != NULL) {
#line 1444 "Assistant.c"
		GtkHeaderBar* _tmp21_;
		GtkWidget* _tmp22_;
		GtkWidget* _tmp23_;
#line 345 "../deja-dup/Assistant.vala"
		_tmp21_ = area;
#line 345 "../deja-dup/Assistant.vala"
		_tmp22_ = self->priv->close_button;
#line 345 "../deja-dup/Assistant.vala"
		gtk_container_remove ((GtkContainer*) _tmp21_, _tmp22_);
#line 345 "../deja-dup/Assistant.vala"
		_tmp23_ = self->priv->close_button;
#line 345 "../deja-dup/Assistant.vala"
		deja_dup_destroy_widget (_tmp23_);
#line 345 "../deja-dup/Assistant.vala"
		_g_object_unref0 (self->priv->close_button);
#line 345 "../deja-dup/Assistant.vala"
		self->priv->close_button = NULL;
#line 1462 "Assistant.c"
	}
#line 346 "../deja-dup/Assistant.vala"
	_tmp24_ = self->priv->back_button;
#line 346 "../deja-dup/Assistant.vala"
	if (_tmp24_ != NULL) {
#line 1468 "Assistant.c"
		GtkHeaderBar* _tmp25_;
		GtkWidget* _tmp26_;
		GtkWidget* _tmp27_;
#line 347 "../deja-dup/Assistant.vala"
		_tmp25_ = area;
#line 347 "../deja-dup/Assistant.vala"
		_tmp26_ = self->priv->back_button;
#line 347 "../deja-dup/Assistant.vala"
		gtk_container_remove ((GtkContainer*) _tmp25_, _tmp26_);
#line 347 "../deja-dup/Assistant.vala"
		_tmp27_ = self->priv->back_button;
#line 347 "../deja-dup/Assistant.vala"
		deja_dup_destroy_widget (_tmp27_);
#line 347 "../deja-dup/Assistant.vala"
		_g_object_unref0 (self->priv->back_button);
#line 347 "../deja-dup/Assistant.vala"
		self->priv->back_button = NULL;
#line 1486 "Assistant.c"
	}
#line 348 "../deja-dup/Assistant.vala"
	_tmp28_ = self->priv->resume_button;
#line 348 "../deja-dup/Assistant.vala"
	if (_tmp28_ != NULL) {
#line 1492 "Assistant.c"
		GtkHeaderBar* _tmp29_;
		GtkWidget* _tmp30_;
		GtkWidget* _tmp31_;
#line 349 "../deja-dup/Assistant.vala"
		_tmp29_ = area;
#line 349 "../deja-dup/Assistant.vala"
		_tmp30_ = self->priv->resume_button;
#line 349 "../deja-dup/Assistant.vala"
		gtk_container_remove ((GtkContainer*) _tmp29_, _tmp30_);
#line 349 "../deja-dup/Assistant.vala"
		_tmp31_ = self->priv->resume_button;
#line 349 "../deja-dup/Assistant.vala"
		deja_dup_destroy_widget (_tmp31_);
#line 349 "../deja-dup/Assistant.vala"
		_g_object_unref0 (self->priv->resume_button);
#line 349 "../deja-dup/Assistant.vala"
		self->priv->resume_button = NULL;
#line 1510 "Assistant.c"
	}
#line 350 "../deja-dup/Assistant.vala"
	_tmp32_ = self->forward_button;
#line 350 "../deja-dup/Assistant.vala"
	if (_tmp32_ != NULL) {
#line 1516 "Assistant.c"
		GtkHeaderBar* _tmp33_;
		GtkWidget* _tmp34_;
		GtkWidget* _tmp35_;
#line 351 "../deja-dup/Assistant.vala"
		_tmp33_ = area;
#line 351 "../deja-dup/Assistant.vala"
		_tmp34_ = self->forward_button;
#line 351 "../deja-dup/Assistant.vala"
		gtk_container_remove ((GtkContainer*) _tmp33_, _tmp34_);
#line 351 "../deja-dup/Assistant.vala"
		_tmp35_ = self->forward_button;
#line 351 "../deja-dup/Assistant.vala"
		deja_dup_destroy_widget (_tmp35_);
#line 351 "../deja-dup/Assistant.vala"
		_g_object_unref0 (self->forward_button);
#line 351 "../deja-dup/Assistant.vala"
		self->forward_button = NULL;
#line 1534 "Assistant.c"
	}
#line 352 "../deja-dup/Assistant.vala"
	_tmp36_ = self->priv->apply_button;
#line 352 "../deja-dup/Assistant.vala"
	if (_tmp36_ != NULL) {
#line 1540 "Assistant.c"
		GtkHeaderBar* _tmp37_;
		GtkWidget* _tmp38_;
		GtkWidget* _tmp39_;
#line 353 "../deja-dup/Assistant.vala"
		_tmp37_ = area;
#line 353 "../deja-dup/Assistant.vala"
		_tmp38_ = self->priv->apply_button;
#line 353 "../deja-dup/Assistant.vala"
		gtk_container_remove ((GtkContainer*) _tmp37_, _tmp38_);
#line 353 "../deja-dup/Assistant.vala"
		_tmp39_ = self->priv->apply_button;
#line 353 "../deja-dup/Assistant.vala"
		deja_dup_destroy_widget (_tmp39_);
#line 353 "../deja-dup/Assistant.vala"
		_g_object_unref0 (self->priv->apply_button);
#line 353 "../deja-dup/Assistant.vala"
		self->priv->apply_button = NULL;
#line 1558 "Assistant.c"
	}
#line 355 "../deja-dup/Assistant.vala"
	_tmp40_ = show_forward;
#line 355 "../deja-dup/Assistant.vala"
	if (_tmp40_) {
#line 1564 "Assistant.c"
		AssistantPageInfo* _tmp41_;
		const gchar* _tmp42_;
		GtkButton* _tmp43_;
		gboolean _tmp44_;
#line 356 "../deja-dup/Assistant.vala"
		_tmp41_ = info;
#line 356 "../deja-dup/Assistant.vala"
		_tmp42_ = _tmp41_->forward_text;
#line 356 "../deja-dup/Assistant.vala"
		_tmp43_ = assistant_add_button (self, _tmp42_, ASSISTANT_FORWARD);
#line 356 "../deja-dup/Assistant.vala"
		_g_object_unref0 (self->forward_button);
#line 356 "../deja-dup/Assistant.vala"
		self->forward_button = (GtkWidget*) _tmp43_;
#line 357 "../deja-dup/Assistant.vala"
		_tmp44_ = has_default;
#line 357 "../deja-dup/Assistant.vala"
		if (!_tmp44_) {
#line 1583 "Assistant.c"
			GtkWidget* _tmp45_;
#line 358 "../deja-dup/Assistant.vala"
			_tmp45_ = self->forward_button;
#line 358 "../deja-dup/Assistant.vala"
			assistant_make_button_default (self, _tmp45_);
#line 1589 "Assistant.c"
		}
#line 359 "../deja-dup/Assistant.vala"
		has_default = TRUE;
#line 1593 "Assistant.c"
	}
#line 361 "../deja-dup/Assistant.vala"
	_tmp46_ = show_resume;
#line 361 "../deja-dup/Assistant.vala"
	if (_tmp46_) {
#line 1599 "Assistant.c"
		GtkButton* _tmp47_;
		gboolean _tmp48_;
#line 362 "../deja-dup/Assistant.vala"
		_tmp47_ = assistant_add_button (self, _ ("_Resume Later"), ASSISTANT_RESUME);
#line 362 "../deja-dup/Assistant.vala"
		_g_object_unref0 (self->priv->resume_button);
#line 362 "../deja-dup/Assistant.vala"
		self->priv->resume_button = (GtkWidget*) _tmp47_;
#line 363 "../deja-dup/Assistant.vala"
		_tmp48_ = has_default;
#line 363 "../deja-dup/Assistant.vala"
		if (!_tmp48_) {
#line 1612 "Assistant.c"
			GtkWidget* _tmp49_;
#line 364 "../deja-dup/Assistant.vala"
			_tmp49_ = self->priv->resume_button;
#line 364 "../deja-dup/Assistant.vala"
			assistant_make_button_default (self, _tmp49_);
#line 1618 "Assistant.c"
		}
#line 365 "../deja-dup/Assistant.vala"
		has_default = TRUE;
#line 1622 "Assistant.c"
	}
#line 367 "../deja-dup/Assistant.vala"
	_tmp50_ = show_back;
#line 367 "../deja-dup/Assistant.vala"
	if (_tmp50_) {
#line 1628 "Assistant.c"
		GtkButton* _tmp51_;
#line 368 "../deja-dup/Assistant.vala"
		_tmp51_ = assistant_add_button (self, _ ("_Back"), ASSISTANT_BACK);
#line 368 "../deja-dup/Assistant.vala"
		_g_object_unref0 (self->priv->back_button);
#line 368 "../deja-dup/Assistant.vala"
		self->priv->back_button = (GtkWidget*) _tmp51_;
#line 1636 "Assistant.c"
	}
#line 369 "../deja-dup/Assistant.vala"
	_tmp52_ = show_close;
#line 369 "../deja-dup/Assistant.vala"
	if (_tmp52_) {
#line 1642 "Assistant.c"
		GtkButton* _tmp53_;
		gboolean _tmp54_;
#line 370 "../deja-dup/Assistant.vala"
		_tmp53_ = assistant_add_button (self, _ ("_Close"), ASSISTANT_CLOSE);
#line 370 "../deja-dup/Assistant.vala"
		_g_object_unref0 (self->priv->close_button);
#line 370 "../deja-dup/Assistant.vala"
		self->priv->close_button = (GtkWidget*) _tmp53_;
#line 371 "../deja-dup/Assistant.vala"
		_tmp54_ = has_default;
#line 371 "../deja-dup/Assistant.vala"
		if (!_tmp54_) {
#line 1655 "Assistant.c"
			GtkWidget* _tmp55_;
#line 372 "../deja-dup/Assistant.vala"
			_tmp55_ = self->priv->close_button;
#line 372 "../deja-dup/Assistant.vala"
			assistant_make_button_default (self, _tmp55_);
#line 1661 "Assistant.c"
		}
#line 373 "../deja-dup/Assistant.vala"
		has_default = TRUE;
#line 1665 "Assistant.c"
	}
#line 375 "../deja-dup/Assistant.vala"
	_tmp56_ = show_cancel;
#line 375 "../deja-dup/Assistant.vala"
	if (_tmp56_) {
#line 1671 "Assistant.c"
		GtkButton* _tmp57_;
#line 376 "../deja-dup/Assistant.vala"
		_tmp57_ = assistant_add_button (self, _ ("_Cancel"), ASSISTANT_CANCEL);
#line 376 "../deja-dup/Assistant.vala"
		_g_object_unref0 (self->priv->cancel_button);
#line 376 "../deja-dup/Assistant.vala"
		self->priv->cancel_button = (GtkWidget*) _tmp57_;
#line 1679 "Assistant.c"
	}
#line 298 "../deja-dup/Assistant.vala"
	_g_object_unref0 (area);
#line 298 "../deja-dup/Assistant.vala"
	_g_free0 (forward_text);
#line 1685 "Assistant.c"
}


static gboolean
assistant_set_first_page (Assistant* self)
{
	gboolean result = FALSE;
#line 379 "../deja-dup/Assistant.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 381 "../deja-dup/Assistant.vala"
	self->current = NULL;
#line 382 "../deja-dup/Assistant.vala"
	assistant_go_forward (self);
#line 383 "../deja-dup/Assistant.vala"
	result = FALSE;
#line 383 "../deja-dup/Assistant.vala"
	return result;
#line 1703 "Assistant.c"
}


static gpointer
_assistant_page_info_ref0 (gpointer self)
{
#line 395 "../deja-dup/Assistant.vala"
	return self ? assistant_page_info_ref (self) : NULL;
#line 1712 "Assistant.c"
}


static gboolean
_assistant_set_first_page_gsource_func (gpointer self)
{
	gboolean result;
	result = assistant_set_first_page ((Assistant*) self);
#line 405 "../deja-dup/Assistant.vala"
	return result;
#line 1723 "Assistant.c"
}


void
assistant_append_page (Assistant* self,
                       GtkWidget* page,
                       AssistantType type,
                       const gchar* forward_text)
{
	gboolean was_empty = FALSE;
	GList* _tmp0_;
	AssistantPageInfo* info = NULL;
	AssistantPageInfo* _tmp1_;
	AssistantPageInfo* _tmp2_;
	GtkWidget* _tmp3_;
	AssistantPageInfo* _tmp4_;
	AssistantPageInfo* _tmp5_;
	gchar* _tmp6_;
	AssistantPageInfo* _tmp7_;
	AssistantPageInfo* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp12_;
#line 387 "../deja-dup/Assistant.vala"
	g_return_if_fail (self != NULL);
#line 387 "../deja-dup/Assistant.vala"
	g_return_if_fail (page != NULL);
#line 387 "../deja-dup/Assistant.vala"
	g_return_if_fail (forward_text != NULL);
#line 389 "../deja-dup/Assistant.vala"
	_tmp0_ = self->priv->infos;
#line 389 "../deja-dup/Assistant.vala"
	was_empty = _tmp0_ == NULL;
#line 391 "../deja-dup/Assistant.vala"
	_tmp1_ = assistant_page_info_new ();
#line 391 "../deja-dup/Assistant.vala"
	info = _tmp1_;
#line 392 "../deja-dup/Assistant.vala"
	_tmp2_ = info;
#line 392 "../deja-dup/Assistant.vala"
	_tmp3_ = _g_object_ref0 (page);
#line 392 "../deja-dup/Assistant.vala"
	_g_object_unref0 (_tmp2_->page);
#line 392 "../deja-dup/Assistant.vala"
	_tmp2_->page = _tmp3_;
#line 393 "../deja-dup/Assistant.vala"
	_tmp4_ = info;
#line 393 "../deja-dup/Assistant.vala"
	_tmp4_->type = type;
#line 394 "../deja-dup/Assistant.vala"
	_tmp5_ = info;
#line 394 "../deja-dup/Assistant.vala"
	_tmp6_ = g_strdup (forward_text);
#line 394 "../deja-dup/Assistant.vala"
	_g_free0 (_tmp5_->forward_text);
#line 394 "../deja-dup/Assistant.vala"
	_tmp5_->forward_text = _tmp6_;
#line 395 "../deja-dup/Assistant.vala"
	_tmp7_ = info;
#line 395 "../deja-dup/Assistant.vala"
	_tmp8_ = _assistant_page_info_ref0 (_tmp7_);
#line 395 "../deja-dup/Assistant.vala"
	self->priv->infos = g_list_append (self->priv->infos, _tmp8_);
#line 397 "../deja-dup/Assistant.vala"
	gtk_widget_show_all (page);
#line 399 "../deja-dup/Assistant.vala"
	_tmp9_ = was_empty;
#line 399 "../deja-dup/Assistant.vala"
	if (_tmp9_) {
#line 1792 "Assistant.c"
		GtkEventBox* _tmp10_;
		GtkRequisition _tmp11_ = {0};
#line 400 "../deja-dup/Assistant.vala"
		_tmp10_ = self->page_box;
#line 400 "../deja-dup/Assistant.vala"
		gtk_widget_get_preferred_size ((GtkWidget*) _tmp10_, NULL, &_tmp11_);
#line 400 "../deja-dup/Assistant.vala"
		self->priv->page_box_req = _tmp11_;
#line 1801 "Assistant.c"
	}
#line 402 "../deja-dup/Assistant.vala"
	assistant_reset_size (self, page);
#line 404 "../deja-dup/Assistant.vala"
	_tmp12_ = was_empty;
#line 404 "../deja-dup/Assistant.vala"
	if (_tmp12_) {
#line 405 "../deja-dup/Assistant.vala"
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _assistant_set_first_page_gsource_func, g_object_ref (self), g_object_unref);
#line 1811 "Assistant.c"
	}
#line 387 "../deja-dup/Assistant.vala"
	_assistant_page_info_unref0 (info);
#line 1815 "Assistant.c"
}


static void
assistant_reset_size (Assistant* self,
                      GtkWidget* page)
{
	GtkRequisition pagereq = {0};
	gint boxw = 0;
	gint boxh = 0;
	GtkEventBox* _tmp0_;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	GtkRequisition _tmp3_ = {0};
	GtkEventBox* _tmp4_;
	GtkRequisition _tmp5_;
	gint _tmp6_;
	GtkRequisition _tmp7_;
	gint _tmp8_;
	GtkRequisition _tmp9_;
	gint _tmp10_;
	GtkRequisition _tmp11_;
	gint _tmp12_;
#line 408 "../deja-dup/Assistant.vala"
	g_return_if_fail (self != NULL);
#line 408 "../deja-dup/Assistant.vala"
	g_return_if_fail (page != NULL);
#line 412 "../deja-dup/Assistant.vala"
	_tmp0_ = self->page_box;
#line 412 "../deja-dup/Assistant.vala"
	gtk_widget_get_size_request ((GtkWidget*) _tmp0_, &_tmp1_, &_tmp2_);
#line 412 "../deja-dup/Assistant.vala"
	boxw = _tmp1_;
#line 412 "../deja-dup/Assistant.vala"
	boxh = _tmp2_;
#line 413 "../deja-dup/Assistant.vala"
	gtk_widget_get_preferred_size (page, NULL, &_tmp3_);
#line 413 "../deja-dup/Assistant.vala"
	pagereq = _tmp3_;
#line 414 "../deja-dup/Assistant.vala"
	_tmp4_ = self->page_box;
#line 414 "../deja-dup/Assistant.vala"
	_tmp5_ = pagereq;
#line 414 "../deja-dup/Assistant.vala"
	_tmp6_ = _tmp5_.width;
#line 414 "../deja-dup/Assistant.vala"
	_tmp7_ = self->priv->page_box_req;
#line 414 "../deja-dup/Assistant.vala"
	_tmp8_ = _tmp7_.width;
#line 414 "../deja-dup/Assistant.vala"
	_tmp9_ = pagereq;
#line 414 "../deja-dup/Assistant.vala"
	_tmp10_ = _tmp9_.height;
#line 414 "../deja-dup/Assistant.vala"
	_tmp11_ = self->priv->page_box_req;
#line 414 "../deja-dup/Assistant.vala"
	_tmp12_ = _tmp11_.height;
#line 414 "../deja-dup/Assistant.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp4_, MAX (boxw, _tmp6_ + _tmp8_), MAX (boxh, _tmp10_ + _tmp12_));
#line 1875 "Assistant.c"
}


void
assistant_set_page_title (Assistant* self,
                          GtkWidget* page,
                          const gchar* title)
{
	GList* _tmp0_;
#line 417 "../deja-dup/Assistant.vala"
	g_return_if_fail (self != NULL);
#line 417 "../deja-dup/Assistant.vala"
	g_return_if_fail (page != NULL);
#line 417 "../deja-dup/Assistant.vala"
	g_return_if_fail (title != NULL);
#line 419 "../deja-dup/Assistant.vala"
	_tmp0_ = self->priv->infos;
#line 1893 "Assistant.c"
	{
		GList* info_collection = NULL;
		GList* info_it = NULL;
#line 419 "../deja-dup/Assistant.vala"
		info_collection = _tmp0_;
#line 419 "../deja-dup/Assistant.vala"
		for (info_it = info_collection; info_it != NULL; info_it = info_it->next) {
#line 1901 "Assistant.c"
			AssistantPageInfo* _tmp1_;
			AssistantPageInfo* info = NULL;
#line 419 "../deja-dup/Assistant.vala"
			_tmp1_ = _assistant_page_info_ref0 ((AssistantPageInfo*) info_it->data);
#line 419 "../deja-dup/Assistant.vala"
			info = _tmp1_;
#line 1908 "Assistant.c"
			{
				AssistantPageInfo* _tmp2_;
				GtkWidget* _tmp3_;
#line 420 "../deja-dup/Assistant.vala"
				_tmp2_ = info;
#line 420 "../deja-dup/Assistant.vala"
				_tmp3_ = _tmp2_->page;
#line 420 "../deja-dup/Assistant.vala"
				if (_tmp3_ == page) {
#line 1918 "Assistant.c"
					AssistantPageInfo* _tmp4_;
					gchar* _tmp5_;
					gboolean _tmp6_ = FALSE;
					GList* _tmp7_;
#line 421 "../deja-dup/Assistant.vala"
					_tmp4_ = info;
#line 421 "../deja-dup/Assistant.vala"
					_tmp5_ = g_strdup (title);
#line 421 "../deja-dup/Assistant.vala"
					_g_free0 (_tmp4_->title);
#line 421 "../deja-dup/Assistant.vala"
					_tmp4_->title = _tmp5_;
#line 422 "../deja-dup/Assistant.vala"
					_tmp7_ = self->current;
#line 422 "../deja-dup/Assistant.vala"
					if (_tmp7_ != NULL) {
#line 1935 "Assistant.c"
						GList* _tmp8_;
						gconstpointer _tmp9_;
						GtkWidget* _tmp10_;
#line 422 "../deja-dup/Assistant.vala"
						_tmp8_ = self->current;
#line 422 "../deja-dup/Assistant.vala"
						_tmp9_ = _tmp8_->data;
#line 422 "../deja-dup/Assistant.vala"
						_tmp10_ = ((AssistantPageInfo*) _tmp9_)->page;
#line 422 "../deja-dup/Assistant.vala"
						_tmp6_ = _tmp10_ == page;
#line 1947 "Assistant.c"
					} else {
#line 422 "../deja-dup/Assistant.vala"
						_tmp6_ = FALSE;
#line 1951 "Assistant.c"
					}
#line 422 "../deja-dup/Assistant.vala"
					if (_tmp6_) {
#line 1955 "Assistant.c"
						AssistantPageInfo* _tmp11_;
#line 423 "../deja-dup/Assistant.vala"
						_tmp11_ = info;
#line 423 "../deja-dup/Assistant.vala"
						assistant_use_title (self, _tmp11_);
#line 1961 "Assistant.c"
					}
#line 424 "../deja-dup/Assistant.vala"
					_assistant_page_info_unref0 (info);
#line 424 "../deja-dup/Assistant.vala"
					break;
#line 1967 "Assistant.c"
				}
#line 419 "../deja-dup/Assistant.vala"
				_assistant_page_info_unref0 (info);
#line 1971 "Assistant.c"
			}
		}
	}
}


Assistant*
assistant_construct (GType object_type)
{
	Assistant * self = NULL;
#line 29 "../deja-dup/Assistant.vala"
	self = (Assistant*) g_object_new (object_type, NULL);
#line 29 "../deja-dup/Assistant.vala"
	return self;
#line 1986 "Assistant.c"
}


gboolean
assistant_get_last_op_was_back (Assistant* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 38 "../deja-dup/Assistant.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 38 "../deja-dup/Assistant.vala"
	_tmp0_ = self->priv->_last_op_was_back;
#line 38 "../deja-dup/Assistant.vala"
	result = _tmp0_;
#line 38 "../deja-dup/Assistant.vala"
	return result;
#line 2003 "Assistant.c"
}


static void
assistant_set_last_op_was_back (Assistant* self,
                                gboolean value)
{
#line 38 "../deja-dup/Assistant.vala"
	g_return_if_fail (self != NULL);
#line 38 "../deja-dup/Assistant.vala"
	if (assistant_get_last_op_was_back (self) != value) {
#line 38 "../deja-dup/Assistant.vala"
		self->priv->_last_op_was_back = value;
#line 38 "../deja-dup/Assistant.vala"
		g_object_notify_by_pspec ((GObject *) self, assistant_properties[ASSISTANT_LAST_OP_WAS_BACK_PROPERTY]);
#line 2019 "Assistant.c"
	}
}


static void
_assistant_handle_response_assistant_response (Assistant* _sender,
                                               gint response,
                                               gpointer self)
{
#line 109 "../deja-dup/Assistant.vala"
	assistant_handle_response ((Assistant*) self, response);
#line 2031 "Assistant.c"
}


static GObject *
assistant_constructor (GType type,
                       guint n_construct_properties,
                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	Assistant * self;
	GtkHeaderBar* _tmp0_;
	GtkHeaderBar* _tmp1_;
	GtkBox* evbox = NULL;
	GtkBox* _tmp2_;
	GtkEventBox* ebox = NULL;
	GtkEventBox* _tmp3_;
	GtkEventBox* _tmp4_;
	GtkBox* ehbox = NULL;
	GtkBox* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkImage* _tmp9_;
	GtkBox* _tmp10_;
	GtkBox* _tmp11_;
	GtkLabel* _tmp12_;
	GtkBox* _tmp13_;
	GtkImage* _tmp14_;
	GtkEventBox* _tmp15_;
	GtkBox* _tmp16_;
	GtkBox* _tmp17_;
	GtkEventBox* _tmp18_;
	GtkEventBox* _tmp19_;
	GtkBox* _tmp20_;
	GtkEventBox* _tmp21_;
	GtkBox* dlg_vbox = NULL;
	GtkBox* _tmp22_;
	GtkBox* _tmp23_;
	GtkBox* _tmp24_;
	GtkBox* _tmp25_;
	GtkBox* _tmp26_;
#line 79 "../deja-dup/Assistant.vala"
	parent_class = G_OBJECT_CLASS (assistant_parent_class);
#line 79 "../deja-dup/Assistant.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 79 "../deja-dup/Assistant.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ASSISTANT, Assistant);
#line 81 "../deja-dup/Assistant.vala"
	(self->priv->infos == NULL) ? NULL : (self->priv->infos = (_g_list_free__assistant_page_info_unref0_ (self->priv->infos), NULL));
#line 81 "../deja-dup/Assistant.vala"
	self->priv->infos = NULL;
#line 83 "../deja-dup/Assistant.vala"
	_tmp0_ = (GtkHeaderBar*) gtk_header_bar_new ();
#line 83 "../deja-dup/Assistant.vala"
	g_object_ref_sink (_tmp0_);
#line 83 "../deja-dup/Assistant.vala"
	_g_object_unref0 (self->priv->header_bar);
#line 83 "../deja-dup/Assistant.vala"
	self->priv->header_bar = _tmp0_;
#line 84 "../deja-dup/Assistant.vala"
	_tmp1_ = self->priv->header_bar;
#line 84 "../deja-dup/Assistant.vala"
	gtk_window_set_titlebar ((GtkWindow*) self, (GtkWidget*) _tmp1_);
#line 86 "../deja-dup/Assistant.vala"
	_tmp2_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 86 "../deja-dup/Assistant.vala"
	g_object_ref_sink (_tmp2_);
#line 86 "../deja-dup/Assistant.vala"
	evbox = _tmp2_;
#line 88 "../deja-dup/Assistant.vala"
	_tmp3_ = (GtkEventBox*) gtk_event_box_new ();
#line 88 "../deja-dup/Assistant.vala"
	g_object_ref_sink (_tmp3_);
#line 88 "../deja-dup/Assistant.vala"
	ebox = _tmp3_;
#line 89 "../deja-dup/Assistant.vala"
	_tmp4_ = ebox;
#line 89 "../deja-dup/Assistant.vala"
	gtk_container_set_border_width ((GtkContainer*) _tmp4_, (guint) 6);
#line 90 "../deja-dup/Assistant.vala"
	_tmp5_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 90 "../deja-dup/Assistant.vala"
	g_object_ref_sink (_tmp5_);
#line 90 "../deja-dup/Assistant.vala"
	ehbox = _tmp5_;
#line 91 "../deja-dup/Assistant.vala"
	_tmp6_ = (GtkLabel*) gtk_label_new ("");
#line 91 "../deja-dup/Assistant.vala"
	g_object_ref_sink (_tmp6_);
#line 91 "../deja-dup/Assistant.vala"
	_g_object_unref0 (self->priv->header_title);
#line 91 "../deja-dup/Assistant.vala"
	self->priv->header_title = _tmp6_;
#line 92 "../deja-dup/Assistant.vala"
	_tmp7_ = self->priv->header_title;
#line 92 "../deja-dup/Assistant.vala"
	gtk_widget_set_name ((GtkWidget*) _tmp7_, "header");
#line 93 "../deja-dup/Assistant.vala"
	_tmp8_ = self->priv->header_title;
#line 93 "../deja-dup/Assistant.vala"
	gtk_label_set_xalign (_tmp8_, 0.f);
#line 94 "../deja-dup/Assistant.vala"
	_tmp9_ = (GtkImage*) gtk_image_new ();
#line 94 "../deja-dup/Assistant.vala"
	g_object_ref_sink (_tmp9_);
#line 94 "../deja-dup/Assistant.vala"
	_g_object_unref0 (self->header_icon);
#line 94 "../deja-dup/Assistant.vala"
	self->header_icon = _tmp9_;
#line 95 "../deja-dup/Assistant.vala"
	_tmp10_ = ehbox;
#line 95 "../deja-dup/Assistant.vala"
	gtk_container_set_border_width ((GtkContainer*) _tmp10_, (guint) 6);
#line 96 "../deja-dup/Assistant.vala"
	_tmp11_ = ehbox;
#line 96 "../deja-dup/Assistant.vala"
	_tmp12_ = self->priv->header_title;
#line 96 "../deja-dup/Assistant.vala"
	gtk_box_pack_start (_tmp11_, (GtkWidget*) _tmp12_, TRUE, TRUE, (guint) 0);
#line 97 "../deja-dup/Assistant.vala"
	_tmp13_ = ehbox;
#line 97 "../deja-dup/Assistant.vala"
	_tmp14_ = self->header_icon;
#line 97 "../deja-dup/Assistant.vala"
	gtk_box_pack_start (_tmp13_, (GtkWidget*) _tmp14_, FALSE, FALSE, (guint) 0);
#line 98 "../deja-dup/Assistant.vala"
	_tmp15_ = ebox;
#line 98 "../deja-dup/Assistant.vala"
	_tmp16_ = ehbox;
#line 98 "../deja-dup/Assistant.vala"
	gtk_container_add ((GtkContainer*) _tmp15_, (GtkWidget*) _tmp16_);
#line 99 "../deja-dup/Assistant.vala"
	_tmp17_ = evbox;
#line 99 "../deja-dup/Assistant.vala"
	_tmp18_ = ebox;
#line 99 "../deja-dup/Assistant.vala"
	gtk_box_pack_start (_tmp17_, (GtkWidget*) _tmp18_, FALSE, FALSE, (guint) 0);
#line 101 "../deja-dup/Assistant.vala"
	_tmp19_ = (GtkEventBox*) gtk_event_box_new ();
#line 101 "../deja-dup/Assistant.vala"
	g_object_ref_sink (_tmp19_);
#line 101 "../deja-dup/Assistant.vala"
	_g_object_unref0 (self->page_box);
#line 101 "../deja-dup/Assistant.vala"
	self->page_box = _tmp19_;
#line 102 "../deja-dup/Assistant.vala"
	_tmp20_ = evbox;
#line 102 "../deja-dup/Assistant.vala"
	_tmp21_ = self->page_box;
#line 102 "../deja-dup/Assistant.vala"
	gtk_box_pack_start (_tmp20_, (GtkWidget*) _tmp21_, TRUE, TRUE, (guint) 0);
#line 104 "../deja-dup/Assistant.vala"
	_tmp22_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 6);
#line 104 "../deja-dup/Assistant.vala"
	g_object_ref_sink (_tmp22_);
#line 104 "../deja-dup/Assistant.vala"
	dlg_vbox = _tmp22_;
#line 105 "../deja-dup/Assistant.vala"
	_tmp23_ = dlg_vbox;
#line 105 "../deja-dup/Assistant.vala"
	_tmp24_ = evbox;
#line 105 "../deja-dup/Assistant.vala"
	gtk_box_pack_start (_tmp23_, (GtkWidget*) _tmp24_, TRUE, TRUE, (guint) 0);
#line 106 "../deja-dup/Assistant.vala"
	_tmp25_ = dlg_vbox;
#line 106 "../deja-dup/Assistant.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp25_);
#line 107 "../deja-dup/Assistant.vala"
	_tmp26_ = dlg_vbox;
#line 107 "../deja-dup/Assistant.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp26_);
#line 109 "../deja-dup/Assistant.vala"
	g_signal_connect_object (self, "response", (GCallback) _assistant_handle_response_assistant_response, self, 0);
#line 79 "../deja-dup/Assistant.vala"
	_g_object_unref0 (dlg_vbox);
#line 79 "../deja-dup/Assistant.vala"
	_g_object_unref0 (ehbox);
#line 79 "../deja-dup/Assistant.vala"
	_g_object_unref0 (ebox);
#line 79 "../deja-dup/Assistant.vala"
	_g_object_unref0 (evbox);
#line 79 "../deja-dup/Assistant.vala"
	return obj;
#line 2216 "Assistant.c"
}


AssistantPageInfo*
assistant_page_info_construct (GType object_type)
{
	AssistantPageInfo* self = NULL;
#line 55 "../deja-dup/Assistant.vala"
	self = (AssistantPageInfo*) g_type_create_instance (object_type);
#line 55 "../deja-dup/Assistant.vala"
	return self;
#line 2228 "Assistant.c"
}


AssistantPageInfo*
assistant_page_info_new (void)
{
#line 55 "../deja-dup/Assistant.vala"
	return assistant_page_info_construct (ASSISTANT_TYPE_PAGE_INFO);
#line 2237 "Assistant.c"
}


static void
assistant_value_page_info_init (GValue* value)
{
#line 55 "../deja-dup/Assistant.vala"
	value->data[0].v_pointer = NULL;
#line 2246 "Assistant.c"
}


static void
assistant_value_page_info_free_value (GValue* value)
{
#line 55 "../deja-dup/Assistant.vala"
	if (value->data[0].v_pointer) {
#line 55 "../deja-dup/Assistant.vala"
		assistant_page_info_unref (value->data[0].v_pointer);
#line 2257 "Assistant.c"
	}
}


static void
assistant_value_page_info_copy_value (const GValue* src_value,
                                      GValue* dest_value)
{
#line 55 "../deja-dup/Assistant.vala"
	if (src_value->data[0].v_pointer) {
#line 55 "../deja-dup/Assistant.vala"
		dest_value->data[0].v_pointer = assistant_page_info_ref (src_value->data[0].v_pointer);
#line 2270 "Assistant.c"
	} else {
#line 55 "../deja-dup/Assistant.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2274 "Assistant.c"
	}
}


static gpointer
assistant_value_page_info_peek_pointer (const GValue* value)
{
#line 55 "../deja-dup/Assistant.vala"
	return value->data[0].v_pointer;
#line 2284 "Assistant.c"
}


static gchar*
assistant_value_page_info_collect_value (GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
#line 55 "../deja-dup/Assistant.vala"
	if (collect_values[0].v_pointer) {
#line 2296 "Assistant.c"
		AssistantPageInfo * object;
		object = collect_values[0].v_pointer;
#line 55 "../deja-dup/Assistant.vala"
		if (object->parent_instance.g_class == NULL) {
#line 55 "../deja-dup/Assistant.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2303 "Assistant.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 55 "../deja-dup/Assistant.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2307 "Assistant.c"
		}
#line 55 "../deja-dup/Assistant.vala"
		value->data[0].v_pointer = assistant_page_info_ref (object);
#line 2311 "Assistant.c"
	} else {
#line 55 "../deja-dup/Assistant.vala"
		value->data[0].v_pointer = NULL;
#line 2315 "Assistant.c"
	}
#line 55 "../deja-dup/Assistant.vala"
	return NULL;
#line 2319 "Assistant.c"
}


static gchar*
assistant_value_page_info_lcopy_value (const GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
	AssistantPageInfo ** object_p;
	object_p = collect_values[0].v_pointer;
#line 55 "../deja-dup/Assistant.vala"
	if (!object_p) {
#line 55 "../deja-dup/Assistant.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2335 "Assistant.c"
	}
#line 55 "../deja-dup/Assistant.vala"
	if (!value->data[0].v_pointer) {
#line 55 "../deja-dup/Assistant.vala"
		*object_p = NULL;
#line 2341 "Assistant.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 55 "../deja-dup/Assistant.vala"
		*object_p = value->data[0].v_pointer;
#line 2345 "Assistant.c"
	} else {
#line 55 "../deja-dup/Assistant.vala"
		*object_p = assistant_page_info_ref (value->data[0].v_pointer);
#line 2349 "Assistant.c"
	}
#line 55 "../deja-dup/Assistant.vala"
	return NULL;
#line 2353 "Assistant.c"
}


GParamSpec*
assistant_param_spec_page_info (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags)
{
	AssistantParamSpecPageInfo* spec;
#line 55 "../deja-dup/Assistant.vala"
	g_return_val_if_fail (g_type_is_a (object_type, ASSISTANT_TYPE_PAGE_INFO), NULL);
#line 55 "../deja-dup/Assistant.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 55 "../deja-dup/Assistant.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 55 "../deja-dup/Assistant.vala"
	return G_PARAM_SPEC (spec);
#line 2373 "Assistant.c"
}


gpointer
assistant_value_get_page_info (const GValue* value)
{
#line 55 "../deja-dup/Assistant.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, ASSISTANT_TYPE_PAGE_INFO), NULL);
#line 55 "../deja-dup/Assistant.vala"
	return value->data[0].v_pointer;
#line 2384 "Assistant.c"
}


void
assistant_value_set_page_info (GValue* value,
                               gpointer v_object)
{
	AssistantPageInfo * old;
#line 55 "../deja-dup/Assistant.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, ASSISTANT_TYPE_PAGE_INFO));
#line 55 "../deja-dup/Assistant.vala"
	old = value->data[0].v_pointer;
#line 55 "../deja-dup/Assistant.vala"
	if (v_object) {
#line 55 "../deja-dup/Assistant.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, ASSISTANT_TYPE_PAGE_INFO));
#line 55 "../deja-dup/Assistant.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 55 "../deja-dup/Assistant.vala"
		value->data[0].v_pointer = v_object;
#line 55 "../deja-dup/Assistant.vala"
		assistant_page_info_ref (value->data[0].v_pointer);
#line 2407 "Assistant.c"
	} else {
#line 55 "../deja-dup/Assistant.vala"
		value->data[0].v_pointer = NULL;
#line 2411 "Assistant.c"
	}
#line 55 "../deja-dup/Assistant.vala"
	if (old) {
#line 55 "../deja-dup/Assistant.vala"
		assistant_page_info_unref (old);
#line 2417 "Assistant.c"
	}
}


void
assistant_value_take_page_info (GValue* value,
                                gpointer v_object)
{
	AssistantPageInfo * old;
#line 55 "../deja-dup/Assistant.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, ASSISTANT_TYPE_PAGE_INFO));
#line 55 "../deja-dup/Assistant.vala"
	old = value->data[0].v_pointer;
#line 55 "../deja-dup/Assistant.vala"
	if (v_object) {
#line 55 "../deja-dup/Assistant.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, ASSISTANT_TYPE_PAGE_INFO));
#line 55 "../deja-dup/Assistant.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 55 "../deja-dup/Assistant.vala"
		value->data[0].v_pointer = v_object;
#line 2439 "Assistant.c"
	} else {
#line 55 "../deja-dup/Assistant.vala"
		value->data[0].v_pointer = NULL;
#line 2443 "Assistant.c"
	}
#line 55 "../deja-dup/Assistant.vala"
	if (old) {
#line 55 "../deja-dup/Assistant.vala"
		assistant_page_info_unref (old);
#line 2449 "Assistant.c"
	}
}


static void
assistant_page_info_class_init (AssistantPageInfoClass * klass)
{
#line 55 "../deja-dup/Assistant.vala"
	assistant_page_info_parent_class = g_type_class_peek_parent (klass);
#line 55 "../deja-dup/Assistant.vala"
	((AssistantPageInfoClass *) klass)->finalize = assistant_page_info_finalize;
#line 2461 "Assistant.c"
}


static void
assistant_page_info_instance_init (AssistantPageInfo * self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 57 "../deja-dup/Assistant.vala"
	_tmp0_ = g_strdup ("");
#line 57 "../deja-dup/Assistant.vala"
	self->title = _tmp0_;
#line 59 "../deja-dup/Assistant.vala"
	_tmp1_ = g_strdup ("");
#line 59 "../deja-dup/Assistant.vala"
	self->forward_text = _tmp1_;
#line 55 "../deja-dup/Assistant.vala"
	self->ref_count = 1;
#line 2480 "Assistant.c"
}


static void
assistant_page_info_finalize (AssistantPageInfo * obj)
{
	AssistantPageInfo * self;
#line 55 "../deja-dup/Assistant.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ASSISTANT_TYPE_PAGE_INFO, AssistantPageInfo);
#line 55 "../deja-dup/Assistant.vala"
	g_signal_handlers_destroy (self);
#line 56 "../deja-dup/Assistant.vala"
	_g_object_unref0 (self->page);
#line 57 "../deja-dup/Assistant.vala"
	_g_free0 (self->title);
#line 59 "../deja-dup/Assistant.vala"
	_g_free0 (self->forward_text);
#line 2498 "Assistant.c"
}


GType
assistant_page_info_get_type (void)
{
	static volatile gsize assistant_page_info_type_id__volatile = 0;
	if (g_once_init_enter (&assistant_page_info_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { assistant_value_page_info_init, assistant_value_page_info_free_value, assistant_value_page_info_copy_value, assistant_value_page_info_peek_pointer, "p", assistant_value_page_info_collect_value, "p", assistant_value_page_info_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (AssistantPageInfoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) assistant_page_info_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AssistantPageInfo), 0, (GInstanceInitFunc) assistant_page_info_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType assistant_page_info_type_id;
		assistant_page_info_type_id = g_type_register_fundamental (g_type_fundamental_next (), "AssistantPageInfo", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&assistant_page_info_type_id__volatile, assistant_page_info_type_id);
	}
	return assistant_page_info_type_id__volatile;
}


gpointer
assistant_page_info_ref (gpointer instance)
{
	AssistantPageInfo * self;
	self = instance;
#line 55 "../deja-dup/Assistant.vala"
	g_atomic_int_inc (&self->ref_count);
#line 55 "../deja-dup/Assistant.vala"
	return instance;
#line 2527 "Assistant.c"
}


void
assistant_page_info_unref (gpointer instance)
{
	AssistantPageInfo * self;
	self = instance;
#line 55 "../deja-dup/Assistant.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 55 "../deja-dup/Assistant.vala"
		ASSISTANT_PAGE_INFO_GET_CLASS (self)->finalize (self);
#line 55 "../deja-dup/Assistant.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2542 "Assistant.c"
	}
}


static void
assistant_class_init (AssistantClass * klass)
{
#line 29 "../deja-dup/Assistant.vala"
	assistant_parent_class = g_type_class_peek_parent (klass);
#line 29 "../deja-dup/Assistant.vala"
	g_type_class_adjust_private_offset (klass, &Assistant_private_offset);
#line 29 "../deja-dup/Assistant.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_assistant_get_property;
#line 29 "../deja-dup/Assistant.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_assistant_set_property;
#line 29 "../deja-dup/Assistant.vala"
	G_OBJECT_CLASS (klass)->constructor = assistant_constructor;
#line 29 "../deja-dup/Assistant.vala"
	G_OBJECT_CLASS (klass)->finalize = assistant_finalize;
#line 29 "../deja-dup/Assistant.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ASSISTANT_LAST_OP_WAS_BACK_PROPERTY, assistant_properties[ASSISTANT_LAST_OP_WAS_BACK_PROPERTY] = g_param_spec_boolean ("last-op-was-back", "last-op-was-back", "last-op-was-back", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 29 "../deja-dup/Assistant.vala"
	assistant_signals[ASSISTANT_RESPONSE_SIGNAL] = g_signal_new ("response", TYPE_ASSISTANT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 29 "../deja-dup/Assistant.vala"
	assistant_signals[ASSISTANT_CANCELED_SIGNAL] = g_signal_new ("canceled", TYPE_ASSISTANT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 29 "../deja-dup/Assistant.vala"
	assistant_signals[ASSISTANT_CLOSED_SIGNAL] = g_signal_new ("closed", TYPE_ASSISTANT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 29 "../deja-dup/Assistant.vala"
	assistant_signals[ASSISTANT_RESUMED_SIGNAL] = g_signal_new ("resumed", TYPE_ASSISTANT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 29 "../deja-dup/Assistant.vala"
	assistant_signals[ASSISTANT_PREPARE_SIGNAL] = g_signal_new ("prepare", TYPE_ASSISTANT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_widget_get_type ());
#line 29 "../deja-dup/Assistant.vala"
	assistant_signals[ASSISTANT_FORWARD_SIGNAL] = g_signal_new ("forward", TYPE_ASSISTANT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 29 "../deja-dup/Assistant.vala"
	assistant_signals[ASSISTANT_BACKWARD_SIGNAL] = g_signal_new ("backward", TYPE_ASSISTANT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2578 "Assistant.c"
}


static void
assistant_instance_init (Assistant * self)
{
#line 29 "../deja-dup/Assistant.vala"
	self->priv = assistant_get_instance_private (self);
#line 38 "../deja-dup/Assistant.vala"
	self->priv->_last_op_was_back = FALSE;
#line 62 "../deja-dup/Assistant.vala"
	self->priv->interrupt_can_continue = TRUE;
#line 63 "../deja-dup/Assistant.vala"
	self->priv->interrupted_from_hidden = FALSE;
#line 66 "../deja-dup/Assistant.vala"
	self->can_resume = FALSE;
#line 2595 "Assistant.c"
}


static void
assistant_finalize (GObject * obj)
{
	Assistant * self;
#line 29 "../deja-dup/Assistant.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ASSISTANT, Assistant);
#line 44 "../deja-dup/Assistant.vala"
	_g_object_unref0 (self->priv->header_title);
#line 45 "../deja-dup/Assistant.vala"
	_g_object_unref0 (self->header_icon);
#line 46 "../deja-dup/Assistant.vala"
	_g_object_unref0 (self->priv->header_bar);
#line 47 "../deja-dup/Assistant.vala"
	_g_object_unref0 (self->priv->back_button);
#line 48 "../deja-dup/Assistant.vala"
	_g_object_unref0 (self->forward_button);
#line 49 "../deja-dup/Assistant.vala"
	_g_object_unref0 (self->priv->cancel_button);
#line 50 "../deja-dup/Assistant.vala"
	_g_object_unref0 (self->priv->close_button);
#line 51 "../deja-dup/Assistant.vala"
	_g_object_unref0 (self->priv->resume_button);
#line 52 "../deja-dup/Assistant.vala"
	_g_object_unref0 (self->priv->apply_button);
#line 53 "../deja-dup/Assistant.vala"
	_g_object_unref0 (self->page_box);
#line 69 "../deja-dup/Assistant.vala"
	(self->priv->infos == NULL) ? NULL : (self->priv->infos = (_g_list_free__assistant_page_info_unref0_ (self->priv->infos), NULL));
#line 29 "../deja-dup/Assistant.vala"
	G_OBJECT_CLASS (assistant_parent_class)->finalize (obj);
#line 2629 "Assistant.c"
}


/**
 * Yes, this is a silly reimplementation of Gtk.Assistant.
 * But Gtk.Assistant has some ridiculous map/unmap logic that resets the page
 * history when unmapped and generally doesn't work when unmapped.  Since
 * continuing to work when hidden is important for us, this is a
 * reimplementation of just the bits we use.
 */
GType
assistant_get_type (void)
{
	static volatile gsize assistant_type_id__volatile = 0;
	if (g_once_init_enter (&assistant_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AssistantClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) assistant_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Assistant), 0, (GInstanceInitFunc) assistant_instance_init, NULL };
		GType assistant_type_id;
		assistant_type_id = g_type_register_static (gtk_window_get_type (), "Assistant", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		Assistant_private_offset = g_type_add_instance_private (assistant_type_id, sizeof (AssistantPrivate));
		g_once_init_leave (&assistant_type_id__volatile, assistant_type_id);
	}
	return assistant_type_id__volatile;
}


static void
_vala_assistant_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	Assistant * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_ASSISTANT, Assistant);
#line 29 "../deja-dup/Assistant.vala"
	switch (property_id) {
#line 29 "../deja-dup/Assistant.vala"
		case ASSISTANT_LAST_OP_WAS_BACK_PROPERTY:
#line 29 "../deja-dup/Assistant.vala"
		g_value_set_boolean (value, assistant_get_last_op_was_back (self));
#line 29 "../deja-dup/Assistant.vala"
		break;
#line 2671 "Assistant.c"
		default:
#line 29 "../deja-dup/Assistant.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../deja-dup/Assistant.vala"
		break;
#line 2677 "Assistant.c"
	}
}


static void
_vala_assistant_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	Assistant * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_ASSISTANT, Assistant);
#line 29 "../deja-dup/Assistant.vala"
	switch (property_id) {
#line 29 "../deja-dup/Assistant.vala"
		case ASSISTANT_LAST_OP_WAS_BACK_PROPERTY:
#line 29 "../deja-dup/Assistant.vala"
		assistant_set_last_op_was_back (self, g_value_get_boolean (value));
#line 29 "../deja-dup/Assistant.vala"
		break;
#line 2698 "Assistant.c"
		default:
#line 29 "../deja-dup/Assistant.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../deja-dup/Assistant.vala"
		break;
#line 2704 "Assistant.c"
	}
}



