/* Prompt.c generated by valac 0.42.5, the Vala compiler
 * generated from Prompt.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 2 -*- */
/*
    This file is part of Déjà Dup.
    For copyright information, see AUTHORS.

    Déjà Dup is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Déjà Dup is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Déjà Dup.  If not, see <http://www.gnu.org/licenses/>.
*/


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include "deja.h"
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))



void prompt (GtkApplication* app);
void show_prompt_notification (GtkApplication* app);
gchar* get_header (void);
gchar* get_body (void);
gchar* get_cancel_button (gboolean mnemonics);
gchar* get_ok_button (gboolean mnemonics);


void
prompt (GtkApplication* app)
{
#line 22 "../deja-dup/Prompt.vala"
	g_return_if_fail (app != NULL);
#line 24 "../deja-dup/Prompt.vala"
	deja_dup_update_prompt_time (FALSE);
#line 25 "../deja-dup/Prompt.vala"
	show_prompt_notification (app);
#line 58 "Prompt.c"
}


gchar*
get_header (void)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 30 "../deja-dup/Prompt.vala"
	_tmp0_ = g_strdup (_ ("Keep your files safe by backing up regularly"));
#line 30 "../deja-dup/Prompt.vala"
	result = _tmp0_;
#line 30 "../deja-dup/Prompt.vala"
	return result;
#line 73 "Prompt.c"
}


gchar*
get_body (void)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 35 "../deja-dup/Prompt.vala"
	_tmp0_ = g_strdup (_ ("Important documents, data, and settings can be protected by storing th" \
"em in a backup. In the case of a disaster, you would be able to recove" \
"r them from that backup."));
#line 35 "../deja-dup/Prompt.vala"
	result = _tmp0_;
#line 35 "../deja-dup/Prompt.vala"
	return result;
#line 88 "Prompt.c"
}


static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
#line 1477 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1477 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1477 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1478 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1478 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 111 "Prompt.c"
	} else {
#line 1478 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 115 "Prompt.c"
	}
#line 1478 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1478 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 121 "Prompt.c"
	} else {
#line 1478 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 125 "Prompt.c"
	}
#line 1478 "glib-2.0.vapi"
	if (_tmp0_) {
#line 129 "Prompt.c"
		gchar* _tmp2_;
#line 1479 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1479 "glib-2.0.vapi"
		result = _tmp2_;
#line 1479 "glib-2.0.vapi"
		return result;
#line 137 "Prompt.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1482 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1482 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1482 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error_);
#line 1482 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1482 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1482 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1482 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1482 "glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 165 "Prompt.c"
				goto __catch4_g_regex_error;
			}
#line 1482 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1482 "glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1482 "glib-2.0.vapi"
			return NULL;
#line 174 "Prompt.c"
		}
#line 1483 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1483 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error_);
#line 1483 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1483 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1483 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1483 "glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 188 "Prompt.c"
				goto __catch4_g_regex_error;
			}
#line 1483 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1483 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1483 "glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1483 "glib-2.0.vapi"
			return NULL;
#line 199 "Prompt.c"
		}
#line 1483 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1483 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1483 "glib-2.0.vapi"
		result = _tmp10_;
#line 1483 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1483 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1483 "glib-2.0.vapi"
		return result;
#line 213 "Prompt.c"
	}
	goto __finally4;
	__catch4_g_regex_error:
	{
		GError* e = NULL;
#line 1481 "glib-2.0.vapi"
		e = _inner_error_;
#line 1481 "glib-2.0.vapi"
		_inner_error_ = NULL;
#line 1485 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1481 "glib-2.0.vapi"
		_g_error_free0 (e);
#line 227 "Prompt.c"
	}
	__finally4:
#line 1481 "glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1481 "glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1481 "glib-2.0.vapi"
		g_clear_error (&_inner_error_);
#line 1481 "glib-2.0.vapi"
		return NULL;
#line 238 "Prompt.c"
	}
}


gchar*
get_cancel_button (gboolean mnemonics)
{
	gchar* result = NULL;
	gchar* rv = NULL;
	gchar* _tmp0_;
#line 40 "../deja-dup/Prompt.vala"
	_tmp0_ = g_strdup (_ ("_Don't Show Again"));
#line 40 "../deja-dup/Prompt.vala"
	rv = _tmp0_;
#line 41 "../deja-dup/Prompt.vala"
	if (!mnemonics) {
#line 255 "Prompt.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
#line 42 "../deja-dup/Prompt.vala"
		_tmp1_ = rv;
#line 42 "../deja-dup/Prompt.vala"
		_tmp2_ = string_replace (_tmp1_, "_", "");
#line 42 "../deja-dup/Prompt.vala"
		_g_free0 (rv);
#line 42 "../deja-dup/Prompt.vala"
		rv = _tmp2_;
#line 266 "Prompt.c"
	}
#line 43 "../deja-dup/Prompt.vala"
	result = rv;
#line 43 "../deja-dup/Prompt.vala"
	return result;
#line 272 "Prompt.c"
}


gchar*
get_ok_button (gboolean mnemonics)
{
	gchar* result = NULL;
	gchar* rv = NULL;
	gchar* _tmp0_;
#line 48 "../deja-dup/Prompt.vala"
	_tmp0_ = g_strdup (_ ("_Open Backup Settings"));
#line 48 "../deja-dup/Prompt.vala"
	rv = _tmp0_;
#line 49 "../deja-dup/Prompt.vala"
	if (!mnemonics) {
#line 288 "Prompt.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
#line 50 "../deja-dup/Prompt.vala"
		_tmp1_ = rv;
#line 50 "../deja-dup/Prompt.vala"
		_tmp2_ = string_replace (_tmp1_, "_", "");
#line 50 "../deja-dup/Prompt.vala"
		_g_free0 (rv);
#line 50 "../deja-dup/Prompt.vala"
		rv = _tmp2_;
#line 299 "Prompt.c"
	}
#line 51 "../deja-dup/Prompt.vala"
	result = rv;
#line 51 "../deja-dup/Prompt.vala"
	return result;
#line 305 "Prompt.c"
}


void
show_prompt_notification (GtkApplication* app)
{
	GNotification* note = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GNotification* _tmp2_;
	GNotification* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GThemedIcon* _tmp6_;
	GThemedIcon* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
#line 54 "../deja-dup/Prompt.vala"
	g_return_if_fail (app != NULL);
#line 56 "../deja-dup/Prompt.vala"
	_tmp0_ = get_header ();
#line 56 "../deja-dup/Prompt.vala"
	_tmp1_ = _tmp0_;
#line 56 "../deja-dup/Prompt.vala"
	_tmp2_ = g_notification_new (_tmp1_);
#line 56 "../deja-dup/Prompt.vala"
	_tmp3_ = _tmp2_;
#line 56 "../deja-dup/Prompt.vala"
	_g_free0 (_tmp1_);
#line 56 "../deja-dup/Prompt.vala"
	note = _tmp3_;
#line 57 "../deja-dup/Prompt.vala"
	_tmp4_ = get_body ();
#line 57 "../deja-dup/Prompt.vala"
	_tmp5_ = _tmp4_;
#line 57 "../deja-dup/Prompt.vala"
	g_notification_set_body (note, _tmp5_);
#line 57 "../deja-dup/Prompt.vala"
	_g_free0 (_tmp5_);
#line 58 "../deja-dup/Prompt.vala"
	_tmp6_ = (GThemedIcon*) g_themed_icon_new (ICON_NAME);
#line 58 "../deja-dup/Prompt.vala"
	_tmp7_ = _tmp6_;
#line 58 "../deja-dup/Prompt.vala"
	g_notification_set_icon (note, (GIcon*) _tmp7_);
#line 58 "../deja-dup/Prompt.vala"
	_g_object_unref0 (_tmp7_);
#line 59 "../deja-dup/Prompt.vala"
	g_notification_set_default_action (note, "app.prompt-ok");
#line 60 "../deja-dup/Prompt.vala"
	_tmp8_ = get_cancel_button (FALSE);
#line 60 "../deja-dup/Prompt.vala"
	_tmp9_ = _tmp8_;
#line 60 "../deja-dup/Prompt.vala"
	g_notification_add_button (note, _tmp9_, "app.prompt-cancel");
#line 60 "../deja-dup/Prompt.vala"
	_g_free0 (_tmp9_);
#line 61 "../deja-dup/Prompt.vala"
	_tmp10_ = get_ok_button (FALSE);
#line 61 "../deja-dup/Prompt.vala"
	_tmp11_ = _tmp10_;
#line 61 "../deja-dup/Prompt.vala"
	g_notification_add_button (note, _tmp11_, "app.prompt-ok");
#line 61 "../deja-dup/Prompt.vala"
	_g_free0 (_tmp11_);
#line 62 "../deja-dup/Prompt.vala"
	g_application_send_notification ((GApplication*) app, "prompt", note);
#line 54 "../deja-dup/Prompt.vala"
	_g_object_unref0 (note);
#line 377 "Prompt.c"
}



