/* StatusIcon.c generated by valac 0.42.5, the Vala compiler
 * generated from StatusIcon.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 2 -*- */
/*
    This file is part of Déjà Dup.
    For copyright information, see AUTHORS.

    Déjà Dup is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Déjà Dup is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Déjà Dup.  If not, see <http://www.gnu.org/licenses/>.
*/


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gtk/gtk.h>
#include "deja.h"
#include <glib/gi18n-lib.h>
#include <gio/gio.h>


#define TYPE_STATUS_ICON (status_icon_get_type ())
#define STATUS_ICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STATUS_ICON, StatusIcon))
#define STATUS_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STATUS_ICON, StatusIconClass))
#define IS_STATUS_ICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STATUS_ICON))
#define IS_STATUS_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STATUS_ICON))
#define STATUS_ICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STATUS_ICON, StatusIconClass))

typedef struct _StatusIcon StatusIcon;
typedef struct _StatusIconClass StatusIconClass;
typedef struct _StatusIconPrivate StatusIconPrivate;
enum  {
	STATUS_ICON_0_PROPERTY,
	STATUS_ICON_WINDOW_PROPERTY,
	STATUS_ICON_OP_PROPERTY,
	STATUS_ICON_AUTOMATIC_PROPERTY,
	STATUS_ICON_NUM_PROPERTIES
};
static GParamSpec* status_icon_properties[STATUS_ICON_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_SHELL_STATUS_ICON (shell_status_icon_get_type ())
#define SHELL_STATUS_ICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SHELL_STATUS_ICON, ShellStatusIcon))
#define SHELL_STATUS_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SHELL_STATUS_ICON, ShellStatusIconClass))
#define IS_SHELL_STATUS_ICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SHELL_STATUS_ICON))
#define IS_SHELL_STATUS_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SHELL_STATUS_ICON))
#define SHELL_STATUS_ICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SHELL_STATUS_ICON, ShellStatusIconClass))

typedef struct _ShellStatusIcon ShellStatusIcon;
typedef struct _ShellStatusIconClass ShellStatusIconClass;
enum  {
	STATUS_ICON_SHOW_WINDOW_SIGNAL,
	STATUS_ICON_NUM_SIGNALS
};
static guint status_icon_signals[STATUS_ICON_NUM_SIGNALS] = {0};
typedef struct _ShellStatusIconPrivate ShellStatusIconPrivate;
enum  {
	SHELL_STATUS_ICON_0_PROPERTY,
	SHELL_STATUS_ICON_NUM_PROPERTIES
};
static GParamSpec* shell_status_icon_properties[SHELL_STATUS_ICON_NUM_PROPERTIES];

struct _StatusIcon {
	GObject parent_instance;
	StatusIconPrivate * priv;
	gchar* action;
	gdouble progress;
};

struct _StatusIconClass {
	GObjectClass parent_class;
	void (*done) (StatusIcon* self, gboolean success, gboolean cancelled, const gchar* detail);
	void (*update_progress) (StatusIcon* self);
};

struct _StatusIconPrivate {
	GtkWindow* _window;
	DejaDupOperation* _op;
	gboolean _automatic;
};

struct _ShellStatusIcon {
	StatusIcon parent_instance;
	ShellStatusIconPrivate * priv;
};

struct _ShellStatusIconClass {
	StatusIconClass parent_class;
};


static gint StatusIcon_private_offset;
static gpointer status_icon_parent_class = NULL;
static gpointer shell_status_icon_parent_class = NULL;

GType status_icon_get_type (void) G_GNUC_CONST;
StatusIcon* status_icon_create (GtkWindow* window,
                                DejaDupOperation* op,
                                gboolean automatic);
ShellStatusIcon* shell_status_icon_new (GtkWindow* window,
                                        DejaDupOperation* op,
                                        gboolean automatic);
ShellStatusIcon* shell_status_icon_construct (GType object_type,
                                              GtkWindow* window,
                                              DejaDupOperation* op,
                                              gboolean automatic);
GType shell_status_icon_get_type (void) G_GNUC_CONST;
static void status_icon_set_action_desc (StatusIcon* self,
                                  DejaDupOperation* op,
                                  const gchar* action);
void status_icon_update_progress (StatusIcon* self);
static void status_icon_note_progress (StatusIcon* self,
                                DejaDupOperation* op,
                                gdouble progress);
void status_icon_done (StatusIcon* self,
                       gboolean success,
                       gboolean cancelled,
                       const gchar* detail);
static void status_icon_real_done (StatusIcon* self,
                            gboolean success,
                            gboolean cancelled,
                            const gchar* detail);
DejaDupOperation* status_icon_get_op (StatusIcon* self);
static void status_icon_real_update_progress (StatusIcon* self);
StatusIcon* status_icon_construct (GType object_type);
GtkWindow* status_icon_get_window (StatusIcon* self);
static void status_icon_set_window (StatusIcon* self,
                             GtkWindow* value);
static void status_icon_set_op (StatusIcon* self,
                         DejaDupOperation* value);
gboolean status_icon_get_automatic (StatusIcon* self);
static void status_icon_set_automatic (StatusIcon* self,
                                gboolean value);
static GObject * status_icon_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
static void _status_icon_set_action_desc_deja_dup_operation_action_desc_changed (DejaDupOperation* _sender,
                                                                          const gchar* action,
                                                                          gpointer self);
static void _status_icon_note_progress_deja_dup_operation_progress (DejaDupOperation* _sender,
                                                             gdouble percent,
                                                             gpointer self);
static void status_icon_finalize (GObject * obj);
static void _vala_status_icon_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_status_icon_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
static GObject * shell_status_icon_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);


static inline gpointer
status_icon_get_instance_private (StatusIcon* self)
{
	return G_STRUCT_MEMBER_P (self, StatusIcon_private_offset);
}


StatusIcon*
status_icon_create (GtkWindow* window,
                    DejaDupOperation* op,
                    gboolean automatic)
{
	StatusIcon* result = NULL;
	ShellStatusIcon* _tmp0_;
#line 24 "../deja-dup/StatusIcon.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 24 "../deja-dup/StatusIcon.vala"
	g_return_val_if_fail (op != NULL, NULL);
#line 26 "../deja-dup/StatusIcon.vala"
	_tmp0_ = shell_status_icon_new (window, op, automatic);
#line 26 "../deja-dup/StatusIcon.vala"
	result = (StatusIcon*) _tmp0_;
#line 26 "../deja-dup/StatusIcon.vala"
	return result;
#line 197 "StatusIcon.c"
}


static void
status_icon_set_action_desc (StatusIcon* self,
                             DejaDupOperation* op,
                             const gchar* action)
{
	gchar* _tmp0_;
#line 42 "../deja-dup/StatusIcon.vala"
	g_return_if_fail (self != NULL);
#line 42 "../deja-dup/StatusIcon.vala"
	g_return_if_fail (op != NULL);
#line 42 "../deja-dup/StatusIcon.vala"
	g_return_if_fail (action != NULL);
#line 44 "../deja-dup/StatusIcon.vala"
	_tmp0_ = g_strdup (action);
#line 44 "../deja-dup/StatusIcon.vala"
	_g_free0 (self->action);
#line 44 "../deja-dup/StatusIcon.vala"
	self->action = _tmp0_;
#line 45 "../deja-dup/StatusIcon.vala"
	status_icon_update_progress (self);
#line 221 "StatusIcon.c"
}


static void
status_icon_note_progress (StatusIcon* self,
                           DejaDupOperation* op,
                           gdouble progress)
{
#line 48 "../deja-dup/StatusIcon.vala"
	g_return_if_fail (self != NULL);
#line 48 "../deja-dup/StatusIcon.vala"
	g_return_if_fail (op != NULL);
#line 50 "../deja-dup/StatusIcon.vala"
	self->progress = progress;
#line 51 "../deja-dup/StatusIcon.vala"
	status_icon_update_progress (self);
#line 238 "StatusIcon.c"
}


static void
status_icon_real_done (StatusIcon* self,
                       gboolean success,
                       gboolean cancelled,
                       const gchar* detail)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 56 "../deja-dup/StatusIcon.vala"
	if (success) {
#line 56 "../deja-dup/StatusIcon.vala"
		_tmp1_ = !cancelled;
#line 254 "StatusIcon.c"
	} else {
#line 56 "../deja-dup/StatusIcon.vala"
		_tmp1_ = FALSE;
#line 258 "StatusIcon.c"
	}
#line 56 "../deja-dup/StatusIcon.vala"
	if (_tmp1_) {
#line 262 "StatusIcon.c"
		DejaDupOperation* _tmp2_;
		DejaDupToolJobMode _tmp3_;
		DejaDupToolJobMode _tmp4_;
#line 56 "../deja-dup/StatusIcon.vala"
		_tmp2_ = self->priv->_op;
#line 56 "../deja-dup/StatusIcon.vala"
		_tmp3_ = deja_dup_operation_get_mode (_tmp2_);
#line 56 "../deja-dup/StatusIcon.vala"
		_tmp4_ = _tmp3_;
#line 56 "../deja-dup/StatusIcon.vala"
		_tmp0_ = _tmp4_ == DEJA_DUP_TOOL_JOB_MODE_BACKUP;
#line 274 "StatusIcon.c"
	} else {
#line 56 "../deja-dup/StatusIcon.vala"
		_tmp0_ = FALSE;
#line 278 "StatusIcon.c"
	}
#line 56 "../deja-dup/StatusIcon.vala"
	if (_tmp0_) {
#line 282 "StatusIcon.c"
		gchar* msg = NULL;
		gchar* _tmp5_;
		GNotificationPriority priority = 0;
		gchar* more = NULL;
		GNotification* note = NULL;
		const gchar* _tmp8_;
		GNotification* _tmp9_;
		const gchar* _tmp10_;
		GNotification* _tmp13_;
		GThemedIcon* _tmp14_;
		GThemedIcon* _tmp15_;
		GNotification* _tmp16_;
		GNotificationPriority _tmp17_;
		GNotification* _tmp18_;
		GApplication* _tmp19_;
		GNotification* _tmp20_;
#line 57 "../deja-dup/StatusIcon.vala"
		_tmp5_ = g_strdup (_ ("Backup completed"));
#line 57 "../deja-dup/StatusIcon.vala"
		msg = _tmp5_;
#line 58 "../deja-dup/StatusIcon.vala"
		priority = G_NOTIFICATION_PRIORITY_LOW;
#line 60 "../deja-dup/StatusIcon.vala"
		more = NULL;
#line 61 "../deja-dup/StatusIcon.vala"
		if (detail != NULL) {
#line 309 "StatusIcon.c"
			gchar* _tmp6_;
			gchar* _tmp7_;
#line 62 "../deja-dup/StatusIcon.vala"
			_tmp6_ = g_strdup (_ ("Backup finished"));
#line 62 "../deja-dup/StatusIcon.vala"
			_g_free0 (msg);
#line 62 "../deja-dup/StatusIcon.vala"
			msg = _tmp6_;
#line 63 "../deja-dup/StatusIcon.vala"
			_tmp7_ = g_strdup (_ ("Not all files were successfully backed up.  See dialog for more detail" \
"s."));
#line 63 "../deja-dup/StatusIcon.vala"
			_g_free0 (more);
#line 63 "../deja-dup/StatusIcon.vala"
			more = _tmp7_;
#line 64 "../deja-dup/StatusIcon.vala"
			priority = G_NOTIFICATION_PRIORITY_NORMAL;
#line 65 "../deja-dup/StatusIcon.vala"
			g_signal_emit (self, status_icon_signals[STATUS_ICON_SHOW_WINDOW_SIGNAL], 0, FALSE);
#line 328 "StatusIcon.c"
		}
#line 68 "../deja-dup/StatusIcon.vala"
		_tmp8_ = msg;
#line 68 "../deja-dup/StatusIcon.vala"
		_tmp9_ = g_notification_new (_tmp8_);
#line 68 "../deja-dup/StatusIcon.vala"
		note = _tmp9_;
#line 69 "../deja-dup/StatusIcon.vala"
		_tmp10_ = more;
#line 69 "../deja-dup/StatusIcon.vala"
		if (_tmp10_ != NULL) {
#line 340 "StatusIcon.c"
			GNotification* _tmp11_;
			const gchar* _tmp12_;
#line 70 "../deja-dup/StatusIcon.vala"
			_tmp11_ = note;
#line 70 "../deja-dup/StatusIcon.vala"
			_tmp12_ = more;
#line 70 "../deja-dup/StatusIcon.vala"
			g_notification_set_body (_tmp11_, _tmp12_);
#line 349 "StatusIcon.c"
		}
#line 71 "../deja-dup/StatusIcon.vala"
		_tmp13_ = note;
#line 71 "../deja-dup/StatusIcon.vala"
		_tmp14_ = (GThemedIcon*) g_themed_icon_new (ICON_NAME);
#line 71 "../deja-dup/StatusIcon.vala"
		_tmp15_ = _tmp14_;
#line 71 "../deja-dup/StatusIcon.vala"
		g_notification_set_icon (_tmp13_, (GIcon*) _tmp15_);
#line 71 "../deja-dup/StatusIcon.vala"
		_g_object_unref0 (_tmp15_);
#line 72 "../deja-dup/StatusIcon.vala"
		_tmp16_ = note;
#line 72 "../deja-dup/StatusIcon.vala"
		_tmp17_ = priority;
#line 72 "../deja-dup/StatusIcon.vala"
		g_notification_set_priority (_tmp16_, _tmp17_);
#line 73 "../deja-dup/StatusIcon.vala"
		_tmp18_ = note;
#line 73 "../deja-dup/StatusIcon.vala"
		g_notification_set_default_action (_tmp18_, "app.op-show");
#line 74 "../deja-dup/StatusIcon.vala"
		_tmp19_ = g_application_get_default ();
#line 74 "../deja-dup/StatusIcon.vala"
		_tmp20_ = note;
#line 74 "../deja-dup/StatusIcon.vala"
		g_application_send_notification (_tmp19_, "backup-status", _tmp20_);
#line 56 "../deja-dup/StatusIcon.vala"
		_g_object_unref0 (note);
#line 56 "../deja-dup/StatusIcon.vala"
		_g_free0 (more);
#line 56 "../deja-dup/StatusIcon.vala"
		_g_free0 (msg);
#line 383 "StatusIcon.c"
	} else {
		GApplication* _tmp21_;
#line 77 "../deja-dup/StatusIcon.vala"
		_tmp21_ = g_application_get_default ();
#line 77 "../deja-dup/StatusIcon.vala"
		g_application_withdraw_notification (_tmp21_, "backup-status");
#line 390 "StatusIcon.c"
	}
}


void
status_icon_done (StatusIcon* self,
                  gboolean success,
                  gboolean cancelled,
                  const gchar* detail)
{
#line 54 "../deja-dup/StatusIcon.vala"
	g_return_if_fail (self != NULL);
#line 54 "../deja-dup/StatusIcon.vala"
	STATUS_ICON_GET_CLASS (self)->done (self, success, cancelled, detail);
#line 405 "StatusIcon.c"
}


static void
status_icon_real_update_progress (StatusIcon* self)
{
}


void
status_icon_update_progress (StatusIcon* self)
{
#line 81 "../deja-dup/StatusIcon.vala"
	g_return_if_fail (self != NULL);
#line 81 "../deja-dup/StatusIcon.vala"
	STATUS_ICON_GET_CLASS (self)->update_progress (self);
#line 422 "StatusIcon.c"
}


StatusIcon*
status_icon_construct (GType object_type)
{
	StatusIcon * self = NULL;
#line 22 "../deja-dup/StatusIcon.vala"
	self = (StatusIcon*) g_object_new (object_type, NULL);
#line 22 "../deja-dup/StatusIcon.vala"
	return self;
#line 434 "StatusIcon.c"
}


GtkWindow*
status_icon_get_window (StatusIcon* self)
{
	GtkWindow* result;
	GtkWindow* _tmp0_;
#line 30 "../deja-dup/StatusIcon.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../deja-dup/StatusIcon.vala"
	_tmp0_ = self->priv->_window;
#line 30 "../deja-dup/StatusIcon.vala"
	result = _tmp0_;
#line 30 "../deja-dup/StatusIcon.vala"
	return result;
#line 451 "StatusIcon.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 30 "../deja-dup/StatusIcon.vala"
	return self ? g_object_ref (self) : NULL;
#line 460 "StatusIcon.c"
}


static void
status_icon_set_window (StatusIcon* self,
                        GtkWindow* value)
{
#line 30 "../deja-dup/StatusIcon.vala"
	g_return_if_fail (self != NULL);
#line 30 "../deja-dup/StatusIcon.vala"
	if (status_icon_get_window (self) != value) {
#line 472 "StatusIcon.c"
		GtkWindow* _tmp0_;
#line 30 "../deja-dup/StatusIcon.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 30 "../deja-dup/StatusIcon.vala"
		_g_object_unref0 (self->priv->_window);
#line 30 "../deja-dup/StatusIcon.vala"
		self->priv->_window = _tmp0_;
#line 30 "../deja-dup/StatusIcon.vala"
		g_object_notify_by_pspec ((GObject *) self, status_icon_properties[STATUS_ICON_WINDOW_PROPERTY]);
#line 482 "StatusIcon.c"
	}
}


DejaDupOperation*
status_icon_get_op (StatusIcon* self)
{
	DejaDupOperation* result;
	DejaDupOperation* _tmp0_;
#line 31 "../deja-dup/StatusIcon.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../deja-dup/StatusIcon.vala"
	_tmp0_ = self->priv->_op;
#line 31 "../deja-dup/StatusIcon.vala"
	result = _tmp0_;
#line 31 "../deja-dup/StatusIcon.vala"
	return result;
#line 500 "StatusIcon.c"
}


static void
status_icon_set_op (StatusIcon* self,
                    DejaDupOperation* value)
{
#line 31 "../deja-dup/StatusIcon.vala"
	g_return_if_fail (self != NULL);
#line 31 "../deja-dup/StatusIcon.vala"
	if (status_icon_get_op (self) != value) {
#line 512 "StatusIcon.c"
		DejaDupOperation* _tmp0_;
#line 31 "../deja-dup/StatusIcon.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 31 "../deja-dup/StatusIcon.vala"
		_g_object_unref0 (self->priv->_op);
#line 31 "../deja-dup/StatusIcon.vala"
		self->priv->_op = _tmp0_;
#line 31 "../deja-dup/StatusIcon.vala"
		g_object_notify_by_pspec ((GObject *) self, status_icon_properties[STATUS_ICON_OP_PROPERTY]);
#line 522 "StatusIcon.c"
	}
}


gboolean
status_icon_get_automatic (StatusIcon* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 32 "../deja-dup/StatusIcon.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 32 "../deja-dup/StatusIcon.vala"
	_tmp0_ = self->priv->_automatic;
#line 32 "../deja-dup/StatusIcon.vala"
	result = _tmp0_;
#line 32 "../deja-dup/StatusIcon.vala"
	return result;
#line 540 "StatusIcon.c"
}


static void
status_icon_set_automatic (StatusIcon* self,
                           gboolean value)
{
#line 32 "../deja-dup/StatusIcon.vala"
	g_return_if_fail (self != NULL);
#line 32 "../deja-dup/StatusIcon.vala"
	if (status_icon_get_automatic (self) != value) {
#line 32 "../deja-dup/StatusIcon.vala"
		self->priv->_automatic = value;
#line 32 "../deja-dup/StatusIcon.vala"
		g_object_notify_by_pspec ((GObject *) self, status_icon_properties[STATUS_ICON_AUTOMATIC_PROPERTY]);
#line 556 "StatusIcon.c"
	}
}


static void
_status_icon_set_action_desc_deja_dup_operation_action_desc_changed (DejaDupOperation* _sender,
                                                                     const gchar* action,
                                                                     gpointer self)
{
#line 38 "../deja-dup/StatusIcon.vala"
	status_icon_set_action_desc ((StatusIcon*) self, _sender, action);
#line 568 "StatusIcon.c"
}


static void
_status_icon_note_progress_deja_dup_operation_progress (DejaDupOperation* _sender,
                                                        gdouble percent,
                                                        gpointer self)
{
#line 39 "../deja-dup/StatusIcon.vala"
	status_icon_note_progress ((StatusIcon*) self, _sender, percent);
#line 579 "StatusIcon.c"
}


static GObject *
status_icon_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	StatusIcon * self;
	DejaDupOperation* _tmp0_;
	DejaDupOperation* _tmp1_;
#line 37 "../deja-dup/StatusIcon.vala"
	parent_class = G_OBJECT_CLASS (status_icon_parent_class);
#line 37 "../deja-dup/StatusIcon.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 37 "../deja-dup/StatusIcon.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_STATUS_ICON, StatusIcon);
#line 38 "../deja-dup/StatusIcon.vala"
	_tmp0_ = self->priv->_op;
#line 38 "../deja-dup/StatusIcon.vala"
	g_signal_connect_object (_tmp0_, "action-desc-changed", (GCallback) _status_icon_set_action_desc_deja_dup_operation_action_desc_changed, self, 0);
#line 39 "../deja-dup/StatusIcon.vala"
	_tmp1_ = self->priv->_op;
#line 39 "../deja-dup/StatusIcon.vala"
	g_signal_connect_object (_tmp1_, "progress", (GCallback) _status_icon_note_progress_deja_dup_operation_progress, self, 0);
#line 37 "../deja-dup/StatusIcon.vala"
	return obj;
#line 609 "StatusIcon.c"
}


static void
status_icon_class_init (StatusIconClass * klass)
{
#line 22 "../deja-dup/StatusIcon.vala"
	status_icon_parent_class = g_type_class_peek_parent (klass);
#line 22 "../deja-dup/StatusIcon.vala"
	g_type_class_adjust_private_offset (klass, &StatusIcon_private_offset);
#line 22 "../deja-dup/StatusIcon.vala"
	((StatusIconClass *) klass)->done = (void (*) (StatusIcon*, gboolean, gboolean, const gchar*)) status_icon_real_done;
#line 22 "../deja-dup/StatusIcon.vala"
	((StatusIconClass *) klass)->update_progress = (void (*) (StatusIcon*)) status_icon_real_update_progress;
#line 22 "../deja-dup/StatusIcon.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_status_icon_get_property;
#line 22 "../deja-dup/StatusIcon.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_status_icon_set_property;
#line 22 "../deja-dup/StatusIcon.vala"
	G_OBJECT_CLASS (klass)->constructor = status_icon_constructor;
#line 22 "../deja-dup/StatusIcon.vala"
	G_OBJECT_CLASS (klass)->finalize = status_icon_finalize;
#line 22 "../deja-dup/StatusIcon.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), STATUS_ICON_WINDOW_PROPERTY, status_icon_properties[STATUS_ICON_WINDOW_PROPERTY] = g_param_spec_object ("window", "window", "window", gtk_window_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 22 "../deja-dup/StatusIcon.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), STATUS_ICON_OP_PROPERTY, status_icon_properties[STATUS_ICON_OP_PROPERTY] = g_param_spec_object ("op", "op", "op", DEJA_DUP_TYPE_OPERATION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 22 "../deja-dup/StatusIcon.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), STATUS_ICON_AUTOMATIC_PROPERTY, status_icon_properties[STATUS_ICON_AUTOMATIC_PROPERTY] = g_param_spec_boolean ("automatic", "automatic", "automatic", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 22 "../deja-dup/StatusIcon.vala"
	status_icon_signals[STATUS_ICON_SHOW_WINDOW_SIGNAL] = g_signal_new ("show-window", TYPE_STATUS_ICON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 640 "StatusIcon.c"
}


static void
status_icon_instance_init (StatusIcon * self)
{
#line 22 "../deja-dup/StatusIcon.vala"
	self->priv = status_icon_get_instance_private (self);
#line 32 "../deja-dup/StatusIcon.vala"
	self->priv->_automatic = FALSE;
#line 651 "StatusIcon.c"
}


static void
status_icon_finalize (GObject * obj)
{
	StatusIcon * self;
#line 22 "../deja-dup/StatusIcon.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_STATUS_ICON, StatusIcon);
#line 30 "../deja-dup/StatusIcon.vala"
	_g_object_unref0 (self->priv->_window);
#line 31 "../deja-dup/StatusIcon.vala"
	_g_object_unref0 (self->priv->_op);
#line 34 "../deja-dup/StatusIcon.vala"
	_g_free0 (self->action);
#line 22 "../deja-dup/StatusIcon.vala"
	G_OBJECT_CLASS (status_icon_parent_class)->finalize (obj);
#line 669 "StatusIcon.c"
}


GType
status_icon_get_type (void)
{
	static volatile gsize status_icon_type_id__volatile = 0;
	if (g_once_init_enter (&status_icon_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (StatusIconClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) status_icon_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (StatusIcon), 0, (GInstanceInitFunc) status_icon_instance_init, NULL };
		GType status_icon_type_id;
		status_icon_type_id = g_type_register_static (G_TYPE_OBJECT, "StatusIcon", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		StatusIcon_private_offset = g_type_add_instance_private (status_icon_type_id, sizeof (StatusIconPrivate));
		g_once_init_leave (&status_icon_type_id__volatile, status_icon_type_id);
	}
	return status_icon_type_id__volatile;
}


static void
_vala_status_icon_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	StatusIcon * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_STATUS_ICON, StatusIcon);
#line 22 "../deja-dup/StatusIcon.vala"
	switch (property_id) {
#line 22 "../deja-dup/StatusIcon.vala"
		case STATUS_ICON_WINDOW_PROPERTY:
#line 22 "../deja-dup/StatusIcon.vala"
		g_value_set_object (value, status_icon_get_window (self));
#line 22 "../deja-dup/StatusIcon.vala"
		break;
#line 22 "../deja-dup/StatusIcon.vala"
		case STATUS_ICON_OP_PROPERTY:
#line 22 "../deja-dup/StatusIcon.vala"
		g_value_set_object (value, status_icon_get_op (self));
#line 22 "../deja-dup/StatusIcon.vala"
		break;
#line 22 "../deja-dup/StatusIcon.vala"
		case STATUS_ICON_AUTOMATIC_PROPERTY:
#line 22 "../deja-dup/StatusIcon.vala"
		g_value_set_boolean (value, status_icon_get_automatic (self));
#line 22 "../deja-dup/StatusIcon.vala"
		break;
#line 716 "StatusIcon.c"
		default:
#line 22 "../deja-dup/StatusIcon.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../deja-dup/StatusIcon.vala"
		break;
#line 722 "StatusIcon.c"
	}
}


static void
_vala_status_icon_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	StatusIcon * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_STATUS_ICON, StatusIcon);
#line 22 "../deja-dup/StatusIcon.vala"
	switch (property_id) {
#line 22 "../deja-dup/StatusIcon.vala"
		case STATUS_ICON_WINDOW_PROPERTY:
#line 22 "../deja-dup/StatusIcon.vala"
		status_icon_set_window (self, g_value_get_object (value));
#line 22 "../deja-dup/StatusIcon.vala"
		break;
#line 22 "../deja-dup/StatusIcon.vala"
		case STATUS_ICON_OP_PROPERTY:
#line 22 "../deja-dup/StatusIcon.vala"
		status_icon_set_op (self, g_value_get_object (value));
#line 22 "../deja-dup/StatusIcon.vala"
		break;
#line 22 "../deja-dup/StatusIcon.vala"
		case STATUS_ICON_AUTOMATIC_PROPERTY:
#line 22 "../deja-dup/StatusIcon.vala"
		status_icon_set_automatic (self, g_value_get_boolean (value));
#line 22 "../deja-dup/StatusIcon.vala"
		break;
#line 755 "StatusIcon.c"
		default:
#line 22 "../deja-dup/StatusIcon.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../deja-dup/StatusIcon.vala"
		break;
#line 761 "StatusIcon.c"
	}
}


ShellStatusIcon*
shell_status_icon_construct (GType object_type,
                             GtkWindow* window,
                             DejaDupOperation* op,
                             gboolean automatic)
{
	ShellStatusIcon * self = NULL;
#line 86 "../deja-dup/StatusIcon.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 86 "../deja-dup/StatusIcon.vala"
	g_return_val_if_fail (op != NULL, NULL);
#line 88 "../deja-dup/StatusIcon.vala"
	self = (ShellStatusIcon*) g_object_new (object_type, "window", window, "op", op, "automatic", automatic, NULL);
#line 86 "../deja-dup/StatusIcon.vala"
	return self;
#line 781 "StatusIcon.c"
}


ShellStatusIcon*
shell_status_icon_new (GtkWindow* window,
                       DejaDupOperation* op,
                       gboolean automatic)
{
#line 86 "../deja-dup/StatusIcon.vala"
	return shell_status_icon_construct (TYPE_SHELL_STATUS_ICON, window, op, automatic);
#line 792 "StatusIcon.c"
}


static GObject *
shell_status_icon_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ShellStatusIcon * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 91 "../deja-dup/StatusIcon.vala"
	parent_class = G_OBJECT_CLASS (shell_status_icon_parent_class);
#line 91 "../deja-dup/StatusIcon.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 91 "../deja-dup/StatusIcon.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SHELL_STATUS_ICON, ShellStatusIcon);
#line 92 "../deja-dup/StatusIcon.vala"
	_tmp1_ = status_icon_get_automatic ((StatusIcon*) self);
#line 92 "../deja-dup/StatusIcon.vala"
	_tmp2_ = _tmp1_;
#line 92 "../deja-dup/StatusIcon.vala"
	if (_tmp2_) {
#line 819 "StatusIcon.c"
		DejaDupOperation* _tmp3_;
		DejaDupOperation* _tmp4_;
		DejaDupToolJobMode _tmp5_;
		DejaDupToolJobMode _tmp6_;
#line 92 "../deja-dup/StatusIcon.vala"
		_tmp3_ = status_icon_get_op ((StatusIcon*) self);
#line 92 "../deja-dup/StatusIcon.vala"
		_tmp4_ = _tmp3_;
#line 92 "../deja-dup/StatusIcon.vala"
		_tmp5_ = deja_dup_operation_get_mode (_tmp4_);
#line 92 "../deja-dup/StatusIcon.vala"
		_tmp6_ = _tmp5_;
#line 92 "../deja-dup/StatusIcon.vala"
		_tmp0_ = _tmp6_ == DEJA_DUP_TOOL_JOB_MODE_BACKUP;
#line 834 "StatusIcon.c"
	} else {
#line 92 "../deja-dup/StatusIcon.vala"
		_tmp0_ = FALSE;
#line 838 "StatusIcon.c"
	}
#line 92 "../deja-dup/StatusIcon.vala"
	if (_tmp0_) {
#line 842 "StatusIcon.c"
		GNotification* note = NULL;
		GNotification* _tmp7_;
		GNotification* _tmp8_;
		GThemedIcon* _tmp9_;
		GThemedIcon* _tmp10_;
		GNotification* _tmp11_;
		GApplication* _tmp12_;
		GNotification* _tmp13_;
#line 93 "../deja-dup/StatusIcon.vala"
		_tmp7_ = g_notification_new (_ ("Starting scheduled backup"));
#line 93 "../deja-dup/StatusIcon.vala"
		note = _tmp7_;
#line 94 "../deja-dup/StatusIcon.vala"
		_tmp8_ = note;
#line 94 "../deja-dup/StatusIcon.vala"
		_tmp9_ = (GThemedIcon*) g_themed_icon_new (ICON_NAME);
#line 94 "../deja-dup/StatusIcon.vala"
		_tmp10_ = _tmp9_;
#line 94 "../deja-dup/StatusIcon.vala"
		g_notification_set_icon (_tmp8_, (GIcon*) _tmp10_);
#line 94 "../deja-dup/StatusIcon.vala"
		_g_object_unref0 (_tmp10_);
#line 95 "../deja-dup/StatusIcon.vala"
		_tmp11_ = note;
#line 95 "../deja-dup/StatusIcon.vala"
		g_notification_set_default_action (_tmp11_, "app.op-show");
#line 96 "../deja-dup/StatusIcon.vala"
		_tmp12_ = g_application_get_default ();
#line 96 "../deja-dup/StatusIcon.vala"
		_tmp13_ = note;
#line 96 "../deja-dup/StatusIcon.vala"
		g_application_send_notification (_tmp12_, "backup-status", _tmp13_);
#line 92 "../deja-dup/StatusIcon.vala"
		_g_object_unref0 (note);
#line 877 "StatusIcon.c"
	}
#line 91 "../deja-dup/StatusIcon.vala"
	return obj;
#line 881 "StatusIcon.c"
}


static void
shell_status_icon_class_init (ShellStatusIconClass * klass)
{
#line 84 "../deja-dup/StatusIcon.vala"
	shell_status_icon_parent_class = g_type_class_peek_parent (klass);
#line 84 "../deja-dup/StatusIcon.vala"
	G_OBJECT_CLASS (klass)->constructor = shell_status_icon_constructor;
#line 892 "StatusIcon.c"
}


static void
shell_status_icon_instance_init (ShellStatusIcon * self)
{
}


GType
shell_status_icon_get_type (void)
{
	static volatile gsize shell_status_icon_type_id__volatile = 0;
	if (g_once_init_enter (&shell_status_icon_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ShellStatusIconClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) shell_status_icon_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ShellStatusIcon), 0, (GInstanceInitFunc) shell_status_icon_instance_init, NULL };
		GType shell_status_icon_type_id;
		shell_status_icon_type_id = g_type_register_static (TYPE_STATUS_ICON, "ShellStatusIcon", &g_define_type_info, 0);
		g_once_init_leave (&shell_status_icon_type_id__volatile, shell_status_icon_type_id);
	}
	return shell_status_icon_type_id__volatile;
}



