/* DirHandling.c generated by valac 0.42.5, the Vala compiler
 * generated from DirHandling.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 2 -*- */
/*
    This file is part of Déjà Dup.
    For copyright information, see AUTHORS.

    Déjà Dup is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Déjà Dup is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Déjà Dup.  If not, see <http://www.gnu.org/licenses/>.
*/


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);



gchar* deja_dup_get_trash_path (void);
gchar* deja_dup_parse_keywords (const gchar* dir);
GFile* deja_dup_parse_dir (const gchar* dir);
GFile** deja_dup_parse_dir_list (const gchar** dirs,
                                 int dirs_length1,
                                 int* result_length1);
static void _vala_array_add1 (GFile** * array,
                       int* length,
                       int* size,
                       GFile* value);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);


gchar*
deja_dup_get_trash_path (void)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 26 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp0_ = g_get_user_data_dir ();
#line 26 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp1_ = g_build_filename (_tmp0_, "Trash", NULL);
#line 26 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	result = _tmp1_;
#line 26 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	return result;
#line 74 "DirHandling.c"
}


static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
#line 1477 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1477 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1477 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1478 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1478 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 97 "DirHandling.c"
	} else {
#line 1478 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 101 "DirHandling.c"
	}
#line 1478 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1478 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 107 "DirHandling.c"
	} else {
#line 1478 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 111 "DirHandling.c"
	}
#line 1478 "glib-2.0.vapi"
	if (_tmp0_) {
#line 115 "DirHandling.c"
		gchar* _tmp2_;
#line 1479 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1479 "glib-2.0.vapi"
		result = _tmp2_;
#line 1479 "glib-2.0.vapi"
		return result;
#line 123 "DirHandling.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1482 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1482 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1482 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error_);
#line 1482 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1482 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1482 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1482 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1482 "glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 151 "DirHandling.c"
				goto __catch0_g_regex_error;
			}
#line 1482 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1482 "glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1482 "glib-2.0.vapi"
			return NULL;
#line 160 "DirHandling.c"
		}
#line 1483 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1483 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error_);
#line 1483 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1483 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1483 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1483 "glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 174 "DirHandling.c"
				goto __catch0_g_regex_error;
			}
#line 1483 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1483 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1483 "glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1483 "glib-2.0.vapi"
			return NULL;
#line 185 "DirHandling.c"
		}
#line 1483 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1483 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1483 "glib-2.0.vapi"
		result = _tmp10_;
#line 1483 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1483 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1483 "glib-2.0.vapi"
		return result;
#line 199 "DirHandling.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		GError* e = NULL;
#line 1481 "glib-2.0.vapi"
		e = _inner_error_;
#line 1481 "glib-2.0.vapi"
		_inner_error_ = NULL;
#line 1485 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1481 "glib-2.0.vapi"
		_g_error_free0 (e);
#line 213 "DirHandling.c"
	}
	__finally0:
#line 1481 "glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1481 "glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1481 "glib-2.0.vapi"
		g_clear_error (&_inner_error_);
#line 1481 "glib-2.0.vapi"
		return NULL;
#line 224 "DirHandling.c"
	}
}


gchar*
deja_dup_parse_keywords (const gchar* dir)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar** dirs = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar** _tmp9_;
	gint dirs_length1;
	gint _dirs_size_;
	GUserDirectory* enums = NULL;
	GUserDirectory* _tmp10_;
	gint enums_length1;
	gint _enums_size_;
	gchar** _tmp11_;
	gint _tmp11__length1;
	GUserDirectory* _tmp12_;
	gint _tmp12__length1;
	const gchar* _tmp13_;
	const gchar* _tmp42_;
	const gchar* _tmp43_;
	gchar* _tmp44_;
	gboolean _tmp45_ = FALSE;
	const gchar* _tmp46_;
	gchar* _tmp47_;
	gchar* _tmp48_;
	gboolean _tmp49_;
#line 29 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	g_return_val_if_fail (dir != NULL, NULL);
#line 31 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp0_ = g_strdup (dir);
#line 31 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_result_ = _tmp0_;
#line 35 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp1_ = g_strdup ("$DESKTOP");
#line 35 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp2_ = g_strdup ("$DOCUMENTS");
#line 35 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp3_ = g_strdup ("$DOWNLOAD");
#line 35 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp4_ = g_strdup ("$MUSIC");
#line 35 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp5_ = g_strdup ("$PICTURES");
#line 35 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp6_ = g_strdup ("$PUBLIC_SHARE");
#line 35 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp7_ = g_strdup ("$TEMPLATES");
#line 35 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp8_ = g_strdup ("$VIDEOS");
#line 35 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp9_ = g_new0 (gchar*, 8 + 1);
#line 35 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp9_[0] = _tmp1_;
#line 35 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp9_[1] = _tmp2_;
#line 35 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp9_[2] = _tmp3_;
#line 35 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp9_[3] = _tmp4_;
#line 35 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp9_[4] = _tmp5_;
#line 35 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp9_[5] = _tmp6_;
#line 35 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp9_[6] = _tmp7_;
#line 35 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp9_[7] = _tmp8_;
#line 35 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	dirs = _tmp9_;
#line 35 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	dirs_length1 = 8;
#line 35 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_dirs_size_ = dirs_length1;
#line 37 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp10_ = g_new0 (GUserDirectory, 8);
#line 37 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp10_[0] = G_USER_DIRECTORY_DESKTOP;
#line 37 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp10_[1] = G_USER_DIRECTORY_DOCUMENTS;
#line 37 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp10_[2] = G_USER_DIRECTORY_DOWNLOAD;
#line 37 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp10_[3] = G_USER_DIRECTORY_MUSIC;
#line 37 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp10_[4] = G_USER_DIRECTORY_PICTURES;
#line 37 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp10_[5] = G_USER_DIRECTORY_PUBLIC_SHARE;
#line 37 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp10_[6] = G_USER_DIRECTORY_TEMPLATES;
#line 37 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp10_[7] = G_USER_DIRECTORY_VIDEOS;
#line 37 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	enums = _tmp10_;
#line 37 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	enums_length1 = 8;
#line 37 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_enums_size_ = enums_length1;
#line 41 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp11_ = dirs;
#line 41 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp11__length1 = dirs_length1;
#line 41 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp12_ = enums;
#line 41 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp12__length1 = enums_length1;
#line 41 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_vala_assert (_tmp11__length1 == _tmp12__length1, "dirs.length == enums.length");
#line 45 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp13_ = _result_;
#line 45 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	if (g_str_has_prefix (_tmp13_, "$HOME")) {
#line 348 "DirHandling.c"
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		gchar* _tmp16_;
#line 46 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
		_tmp14_ = _result_;
#line 46 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
		_tmp15_ = g_get_home_dir ();
#line 46 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
		_tmp16_ = string_replace (_tmp14_, "$HOME", _tmp15_);
#line 46 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
		_g_free0 (_result_);
#line 46 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
		_result_ = _tmp16_;
#line 362 "DirHandling.c"
	} else {
		const gchar* _tmp17_;
#line 47 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
		_tmp17_ = _result_;
#line 47 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
		if (g_str_has_prefix (_tmp17_, "$TRASH")) {
#line 369 "DirHandling.c"
			const gchar* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
			gchar* _tmp21_;
#line 48 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
			_tmp18_ = _result_;
#line 48 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
			_tmp19_ = deja_dup_get_trash_path ();
#line 48 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
			_tmp20_ = _tmp19_;
#line 48 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
			_tmp21_ = string_replace (_tmp18_, "$TRASH", _tmp20_);
#line 48 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
			_g_free0 (_result_);
#line 48 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
			_result_ = _tmp21_;
#line 48 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
			_g_free0 (_tmp20_);
#line 388 "DirHandling.c"
		} else {
			{
				gint i = 0;
#line 50 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
				i = 0;
#line 394 "DirHandling.c"
				{
					gboolean _tmp22_ = FALSE;
#line 50 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
					_tmp22_ = TRUE;
#line 50 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
					while (TRUE) {
#line 401 "DirHandling.c"
						gint _tmp24_;
						gchar** _tmp25_;
						gint _tmp25__length1;
						const gchar* _tmp26_;
						gchar** _tmp27_;
						gint _tmp27__length1;
						gint _tmp28_;
						const gchar* _tmp29_;
#line 50 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
						if (!_tmp22_) {
#line 412 "DirHandling.c"
							gint _tmp23_;
#line 50 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
							_tmp23_ = i;
#line 50 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
							i = _tmp23_ + 1;
#line 418 "DirHandling.c"
						}
#line 50 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
						_tmp22_ = FALSE;
#line 50 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
						_tmp24_ = i;
#line 50 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
						_tmp25_ = dirs;
#line 50 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
						_tmp25__length1 = dirs_length1;
#line 50 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
						if (!(_tmp24_ < _tmp25__length1)) {
#line 50 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
							break;
#line 432 "DirHandling.c"
						}
#line 51 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
						_tmp26_ = _result_;
#line 51 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
						_tmp27_ = dirs;
#line 51 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
						_tmp27__length1 = dirs_length1;
#line 51 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
						_tmp28_ = i;
#line 51 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
						_tmp29_ = _tmp27_[_tmp28_];
#line 51 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
						if (g_str_has_prefix (_tmp26_, _tmp29_)) {
#line 446 "DirHandling.c"
							gchar* replacement = NULL;
							GUserDirectory* _tmp30_;
							gint _tmp30__length1;
							gint _tmp31_;
							GUserDirectory _tmp32_;
							const gchar* _tmp33_;
							gchar* _tmp34_;
							const gchar* _tmp35_;
							const gchar* _tmp36_;
							gchar** _tmp37_;
							gint _tmp37__length1;
							gint _tmp38_;
							const gchar* _tmp39_;
							const gchar* _tmp40_;
							gchar* _tmp41_;
#line 52 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
							_tmp30_ = enums;
#line 52 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
							_tmp30__length1 = enums_length1;
#line 52 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
							_tmp31_ = i;
#line 52 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
							_tmp32_ = _tmp30_[_tmp31_];
#line 52 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
							_tmp33_ = g_get_user_special_dir (_tmp32_);
#line 52 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
							_tmp34_ = g_strdup (_tmp33_);
#line 52 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
							replacement = _tmp34_;
#line 53 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
							_tmp35_ = replacement;
#line 53 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
							if (_tmp35_ == NULL) {
#line 54 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
								result = NULL;
#line 54 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
								_g_free0 (replacement);
#line 54 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
								enums = (g_free (enums), NULL);
#line 54 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
								dirs = (_vala_array_free (dirs, dirs_length1, (GDestroyNotify) g_free), NULL);
#line 54 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
								_g_free0 (_result_);
#line 54 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
								return result;
#line 492 "DirHandling.c"
							}
#line 55 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
							_tmp36_ = _result_;
#line 55 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
							_tmp37_ = dirs;
#line 55 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
							_tmp37__length1 = dirs_length1;
#line 55 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
							_tmp38_ = i;
#line 55 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
							_tmp39_ = _tmp37_[_tmp38_];
#line 55 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
							_tmp40_ = replacement;
#line 55 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
							_tmp41_ = string_replace (_tmp36_, _tmp39_, _tmp40_);
#line 55 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
							_g_free0 (_result_);
#line 55 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
							_result_ = _tmp41_;
#line 56 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
							_g_free0 (replacement);
#line 56 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
							break;
#line 516 "DirHandling.c"
						}
					}
				}
			}
		}
	}
#line 62 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp42_ = _result_;
#line 62 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp43_ = g_get_user_name ();
#line 62 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp44_ = string_replace (_tmp42_, "$USER", _tmp43_);
#line 62 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_g_free0 (_result_);
#line 62 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_result_ = _tmp44_;
#line 65 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp46_ = _result_;
#line 65 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp47_ = g_uri_parse_scheme (_tmp46_);
#line 65 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp48_ = _tmp47_;
#line 65 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp49_ = _tmp48_ == NULL;
#line 65 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_g_free0 (_tmp48_);
#line 65 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	if (_tmp49_) {
#line 545 "DirHandling.c"
		const gchar* _tmp50_;
#line 65 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
		_tmp50_ = _result_;
#line 65 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
		_tmp45_ = !g_path_is_absolute (_tmp50_);
#line 551 "DirHandling.c"
	} else {
#line 65 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
		_tmp45_ = FALSE;
#line 555 "DirHandling.c"
	}
#line 65 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	if (_tmp45_) {
#line 559 "DirHandling.c"
		const gchar* _tmp51_;
		const gchar* _tmp52_;
		gchar* _tmp53_;
#line 66 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
		_tmp51_ = g_get_home_dir ();
#line 66 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
		_tmp52_ = _result_;
#line 66 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
		_tmp53_ = g_build_filename (_tmp51_, _tmp52_, NULL);
#line 66 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
		_g_free0 (_result_);
#line 66 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
		_result_ = _tmp53_;
#line 573 "DirHandling.c"
	}
#line 68 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	result = _result_;
#line 68 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	enums = (g_free (enums), NULL);
#line 68 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	dirs = (_vala_array_free (dirs, dirs_length1, (GDestroyNotify) g_free), NULL);
#line 68 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	return result;
#line 583 "DirHandling.c"
}


GFile*
deja_dup_parse_dir (const gchar* dir)
{
	GFile* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 71 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	g_return_val_if_fail (dir != NULL, NULL);
#line 73 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp0_ = deja_dup_parse_keywords (dir);
#line 73 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_result_ = _tmp0_;
#line 74 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp1_ = _result_;
#line 74 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	if (_tmp1_ != NULL) {
#line 604 "DirHandling.c"
		const gchar* _tmp2_;
		GFile* _tmp3_;
#line 75 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
		_tmp2_ = _result_;
#line 75 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
		_tmp3_ = g_file_parse_name (_tmp2_);
#line 75 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
		result = _tmp3_;
#line 75 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
		_g_free0 (_result_);
#line 75 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
		return result;
#line 617 "DirHandling.c"
	} else {
#line 77 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
		result = NULL;
#line 77 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
		_g_free0 (_result_);
#line 77 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
		return result;
#line 625 "DirHandling.c"
	}
#line 71 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_g_free0 (_result_);
#line 629 "DirHandling.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 87 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	return self ? g_object_ref (self) : NULL;
#line 638 "DirHandling.c"
}


static void
_vala_array_add1 (GFile** * array,
                  int* length,
                  int* size,
                  GFile* value)
{
#line 87 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	if ((*length) == (*size)) {
#line 87 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 87 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
		*array = g_renew (GFile*, *array, (*size) + 1);
#line 654 "DirHandling.c"
	}
#line 87 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	(*array)[(*length)++] = value;
#line 87 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	(*array)[*length] = NULL;
#line 660 "DirHandling.c"
}


GFile**
deja_dup_parse_dir_list (const gchar** dirs,
                         int dirs_length1,
                         int* result_length1)
{
	GFile** result = NULL;
	GFile** rv = NULL;
	GFile** _tmp0_;
	gint rv_length1;
	gint _rv_size_;
	GFile** _tmp8_;
	gint _tmp8__length1;
#line 82 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp0_ = g_new0 (GFile*, 0 + 1);
#line 82 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	rv = _tmp0_;
#line 82 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	rv_length1 = 0;
#line 82 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_rv_size_ = rv_length1;
#line 684 "DirHandling.c"
	{
		const gchar** s_collection = NULL;
		gint s_collection_length1 = 0;
		gint _s_collection_size_ = 0;
		gint s_it = 0;
#line 84 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
		s_collection = dirs;
#line 84 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
		s_collection_length1 = dirs_length1;
#line 84 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
		for (s_it = 0; s_it < dirs_length1; s_it = s_it + 1) {
#line 696 "DirHandling.c"
			gchar* _tmp1_;
			gchar* s = NULL;
#line 84 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
			_tmp1_ = g_strdup ((gchar*) s_collection[s_it]);
#line 84 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
			s = _tmp1_;
#line 703 "DirHandling.c"
			{
				GFile* f = NULL;
				const gchar* _tmp2_;
				GFile* _tmp3_;
				GFile* _tmp4_;
#line 85 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
				_tmp2_ = s;
#line 85 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
				_tmp3_ = deja_dup_parse_dir (_tmp2_);
#line 85 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
				f = _tmp3_;
#line 86 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
				_tmp4_ = f;
#line 86 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
				if (_tmp4_ != NULL) {
#line 719 "DirHandling.c"
					GFile** _tmp5_;
					gint _tmp5__length1;
					GFile* _tmp6_;
					GFile* _tmp7_;
#line 87 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
					_tmp5_ = rv;
#line 87 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
					_tmp5__length1 = rv_length1;
#line 87 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
					_tmp6_ = f;
#line 87 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
					_tmp7_ = _g_object_ref0 (_tmp6_);
#line 87 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
					_vala_array_add1 (&rv, &rv_length1, &_rv_size_, _tmp7_);
#line 734 "DirHandling.c"
				}
#line 84 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
				_g_object_unref0 (f);
#line 84 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
				_g_free0 (s);
#line 740 "DirHandling.c"
			}
		}
	}
#line 90 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp8_ = rv;
#line 90 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	_tmp8__length1 = rv_length1;
#line 90 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	if (result_length1) {
#line 90 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
		*result_length1 = _tmp8__length1;
#line 752 "DirHandling.c"
	}
#line 90 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	result = _tmp8_;
#line 90 "/builddir/build/BUILD/deja-dup-38.4/libdeja/DirHandling.vala"
	return result;
#line 758 "DirHandling.c"
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



