/* WidgetUtils.c generated by valac 0.42.5, the Vala compiler
 * generated from WidgetUtils.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 2 -*- */
/*
    This file is part of Déjà Dup.
    For copyright information, see AUTHORS.

    Déjà Dup is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Déjà Dup is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Déjà Dup.  If not, see <http://www.gnu.org/licenses/>.
*/


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include "deja.h"
#include <gio/gio.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block3Data Block3Data;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _Block3Data {
	int _ref_count_;
	GtkWidget* w;
};



void deja_dup_show_uri (GtkWindow* parent,
                        const gchar* link);
void deja_dup_destroy_widget (GtkWidget* w);
gboolean deja_dup_user_focused (GtkWidget* win,
                                GdkEventFocus* e);
static gboolean _deja_dup_user_focused_gtk_widget_focus_in_event (GtkWidget* _sender,
                                                           GdkEventFocus* event,
                                                           gpointer self);
void deja_dup_show_background_window_for_shell (GtkWindow* win);
void deja_dup_hide_background_window_for_shell (GtkWindow* win);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static gboolean __lambda8_ (Block3Data* _data3_);
static gboolean ___lambda8__gsource_func (gpointer self);
gboolean deja_dup_start_monitor_if_needed (DejaDupFilteredSettings* settings);
gboolean deja_dup_gui_initialize (GtkWindow* parent,
                                  gboolean show_error);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);


void
deja_dup_show_uri (GtkWindow* parent,
                   const gchar* link)
{
	GError * _inner_error_ = NULL;
#line 24 "../deja-dup/widgets/WidgetUtils.vala"
	g_return_if_fail (link != NULL);
#line 79 "WidgetUtils.c"
	{
#line 27 "../deja-dup/widgets/WidgetUtils.vala"
		gtk_show_uri_on_window (parent, link, gtk_get_current_event_time (), &_inner_error_);
#line 27 "../deja-dup/widgets/WidgetUtils.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 85 "WidgetUtils.c"
			goto __catch6_g_error;
		}
	}
	goto __finally6;
	__catch6_g_error:
	{
		GError* e = NULL;
		GtkMessageDialog* dlg = NULL;
		GtkMessageDialog* _tmp0_;
		GtkMessageDialog* _tmp1_;
		GError* _tmp2_;
		const gchar* _tmp3_;
		GtkMessageDialog* _tmp4_;
		GtkMessageDialog* _tmp5_;
#line 26 "../deja-dup/widgets/WidgetUtils.vala"
		e = _inner_error_;
#line 26 "../deja-dup/widgets/WidgetUtils.vala"
		_inner_error_ = NULL;
#line 29 "../deja-dup/widgets/WidgetUtils.vala"
		_tmp0_ = (GtkMessageDialog*) gtk_message_dialog_new (parent, GTK_DIALOG_DESTROY_WITH_PARENT | GTK_DIALOG_MODAL, GTK_MESSAGE_ERROR, GTK_BUTTONS_OK, _ ("Could not display %s"), link);
#line 29 "../deja-dup/widgets/WidgetUtils.vala"
		g_object_ref_sink (_tmp0_);
#line 29 "../deja-dup/widgets/WidgetUtils.vala"
		dlg = _tmp0_;
#line 30 "../deja-dup/widgets/WidgetUtils.vala"
		_tmp1_ = dlg;
#line 30 "../deja-dup/widgets/WidgetUtils.vala"
		_tmp2_ = e;
#line 30 "../deja-dup/widgets/WidgetUtils.vala"
		_tmp3_ = _tmp2_->message;
#line 30 "../deja-dup/widgets/WidgetUtils.vala"
		gtk_message_dialog_format_secondary_text (_tmp1_, "%s", _tmp3_);
#line 31 "../deja-dup/widgets/WidgetUtils.vala"
		_tmp4_ = dlg;
#line 31 "../deja-dup/widgets/WidgetUtils.vala"
		gtk_dialog_run ((GtkDialog*) _tmp4_);
#line 32 "../deja-dup/widgets/WidgetUtils.vala"
		_tmp5_ = dlg;
#line 32 "../deja-dup/widgets/WidgetUtils.vala"
		deja_dup_destroy_widget ((GtkWidget*) _tmp5_);
#line 26 "../deja-dup/widgets/WidgetUtils.vala"
		_g_object_unref0 (dlg);
#line 26 "../deja-dup/widgets/WidgetUtils.vala"
		_g_error_free0 (e);
#line 130 "WidgetUtils.c"
	}
	__finally6:
#line 26 "../deja-dup/widgets/WidgetUtils.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 26 "../deja-dup/widgets/WidgetUtils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 26 "../deja-dup/widgets/WidgetUtils.vala"
		g_clear_error (&_inner_error_);
#line 26 "../deja-dup/widgets/WidgetUtils.vala"
		return;
#line 141 "WidgetUtils.c"
	}
}


static gboolean
_deja_dup_user_focused_gtk_widget_focus_in_event (GtkWidget* _sender,
                                                  GdkEventFocus* event,
                                                  gpointer self)
{
	gboolean result;
	result = deja_dup_user_focused (_sender, event);
#line 39 "../deja-dup/widgets/WidgetUtils.vala"
	return result;
#line 155 "WidgetUtils.c"
}


gboolean
deja_dup_user_focused (GtkWidget* win,
                       GdkEventFocus* e)
{
	gboolean result = FALSE;
	guint _tmp0_;
#line 36 "../deja-dup/widgets/WidgetUtils.vala"
	g_return_val_if_fail (win != NULL, FALSE);
#line 36 "../deja-dup/widgets/WidgetUtils.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 38 "../deja-dup/widgets/WidgetUtils.vala"
	gtk_window_set_urgency_hint (G_TYPE_CHECK_INSTANCE_CAST (win, gtk_window_get_type (), GtkWindow), FALSE);
#line 39 "../deja-dup/widgets/WidgetUtils.vala"
	g_signal_parse_name ("focus-in-event", gtk_widget_get_type (), &_tmp0_, NULL, FALSE);
#line 39 "../deja-dup/widgets/WidgetUtils.vala"
	g_signal_handlers_disconnect_matched (win, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _deja_dup_user_focused_gtk_widget_focus_in_event, NULL);
#line 40 "../deja-dup/widgets/WidgetUtils.vala"
	result = FALSE;
#line 40 "../deja-dup/widgets/WidgetUtils.vala"
	return result;
#line 179 "WidgetUtils.c"
}


void
deja_dup_show_background_window_for_shell (GtkWindow* win)
{
#line 43 "../deja-dup/widgets/WidgetUtils.vala"
	g_return_if_fail (win != NULL);
#line 45 "../deja-dup/widgets/WidgetUtils.vala"
	gtk_window_set_focus_on_map (win, FALSE);
#line 46 "../deja-dup/widgets/WidgetUtils.vala"
	gtk_window_set_urgency_hint (win, TRUE);
#line 47 "../deja-dup/widgets/WidgetUtils.vala"
	g_signal_connect ((GtkWidget*) win, "focus-in-event", (GCallback) _deja_dup_user_focused_gtk_widget_focus_in_event, NULL);
#line 48 "../deja-dup/widgets/WidgetUtils.vala"
	gtk_widget_show ((GtkWidget*) win);
#line 196 "WidgetUtils.c"
}


void
deja_dup_hide_background_window_for_shell (GtkWindow* win)
{
#line 51 "../deja-dup/widgets/WidgetUtils.vala"
	g_return_if_fail (win != NULL);
#line 53 "../deja-dup/widgets/WidgetUtils.vala"
	gtk_widget_hide ((GtkWidget*) win);
#line 207 "WidgetUtils.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 56 "../deja-dup/widgets/WidgetUtils.vala"
	return self ? g_object_ref (self) : NULL;
#line 216 "WidgetUtils.c"
}


static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 56 "../deja-dup/widgets/WidgetUtils.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 56 "../deja-dup/widgets/WidgetUtils.vala"
	return _data3_;
#line 227 "WidgetUtils.c"
}


static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 56 "../deja-dup/widgets/WidgetUtils.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 56 "../deja-dup/widgets/WidgetUtils.vala"
		_g_object_unref0 (_data3_->w);
#line 56 "../deja-dup/widgets/WidgetUtils.vala"
		g_slice_free (Block3Data, _data3_);
#line 242 "WidgetUtils.c"
	}
}


static gboolean
__lambda8_ (Block3Data* _data3_)
{
	gboolean result = FALSE;
#line 67 "../deja-dup/widgets/WidgetUtils.vala"
	gtk_widget_destroy (_data3_->w);
#line 67 "../deja-dup/widgets/WidgetUtils.vala"
	result = FALSE;
#line 67 "../deja-dup/widgets/WidgetUtils.vala"
	return result;
#line 257 "WidgetUtils.c"
}


static gboolean
___lambda8__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda8_ (self);
#line 67 "../deja-dup/widgets/WidgetUtils.vala"
	return result;
#line 268 "WidgetUtils.c"
}


void
deja_dup_destroy_widget (GtkWidget* w)
{
	Block3Data* _data3_;
	GtkWidget* _tmp0_;
#line 56 "../deja-dup/widgets/WidgetUtils.vala"
	g_return_if_fail (w != NULL);
#line 56 "../deja-dup/widgets/WidgetUtils.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 56 "../deja-dup/widgets/WidgetUtils.vala"
	_data3_->_ref_count_ = 1;
#line 56 "../deja-dup/widgets/WidgetUtils.vala"
	_tmp0_ = _g_object_ref0 (w);
#line 56 "../deja-dup/widgets/WidgetUtils.vala"
	_g_object_unref0 (_data3_->w);
#line 56 "../deja-dup/widgets/WidgetUtils.vala"
	_data3_->w = _tmp0_;
#line 65 "../deja-dup/widgets/WidgetUtils.vala"
	gtk_widget_hide (_data3_->w);
#line 66 "../deja-dup/widgets/WidgetUtils.vala"
	g_object_ref ((GObject*) _data3_->w);
#line 67 "../deja-dup/widgets/WidgetUtils.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda8__gsource_func, block3_data_ref (_data3_), block3_data_unref);
#line 56 "../deja-dup/widgets/WidgetUtils.vala"
	block3_data_unref (_data3_);
#line 56 "../deja-dup/widgets/WidgetUtils.vala"
	_data3_ = NULL;
#line 299 "WidgetUtils.c"
}


gboolean
deja_dup_start_monitor_if_needed (DejaDupFilteredSettings* settings)
{
	gboolean result = FALSE;
#line 70 "../deja-dup/widgets/WidgetUtils.vala"
	g_return_val_if_fail (settings != NULL, FALSE);
#line 72 "../deja-dup/widgets/WidgetUtils.vala"
	if (g_settings_get_boolean ((GSettings*) settings, DEJA_DUP_PERIODIC_KEY)) {
#line 311 "WidgetUtils.c"
		gchar* monitor_exec = NULL;
		const gchar* _tmp0_;
		gchar* _tmp1_;
		gboolean _tmp2_ = FALSE;
		const gchar* _tmp3_;
		gchar** _tmp8_;
		gchar** _tmp9_;
		gint _tmp9__length1;
		const gchar* _tmp10_;
#line 73 "../deja-dup/widgets/WidgetUtils.vala"
		_tmp0_ = g_getenv ("DEJA_DUP_MONITOR_EXEC");
#line 73 "../deja-dup/widgets/WidgetUtils.vala"
		_tmp1_ = g_strdup (_tmp0_);
#line 73 "../deja-dup/widgets/WidgetUtils.vala"
		monitor_exec = _tmp1_;
#line 74 "../deja-dup/widgets/WidgetUtils.vala"
		_tmp3_ = monitor_exec;
#line 74 "../deja-dup/widgets/WidgetUtils.vala"
		if (_tmp3_ == NULL) {
#line 74 "../deja-dup/widgets/WidgetUtils.vala"
			_tmp2_ = TRUE;
#line 333 "WidgetUtils.c"
		} else {
			const gchar* _tmp4_;
			gint _tmp5_;
			gint _tmp6_;
#line 74 "../deja-dup/widgets/WidgetUtils.vala"
			_tmp4_ = monitor_exec;
#line 74 "../deja-dup/widgets/WidgetUtils.vala"
			_tmp5_ = strlen (_tmp4_);
#line 74 "../deja-dup/widgets/WidgetUtils.vala"
			_tmp6_ = _tmp5_;
#line 74 "../deja-dup/widgets/WidgetUtils.vala"
			_tmp2_ = _tmp6_ == 0;
#line 346 "WidgetUtils.c"
		}
#line 74 "../deja-dup/widgets/WidgetUtils.vala"
		if (_tmp2_) {
#line 350 "WidgetUtils.c"
			gchar* _tmp7_;
#line 75 "../deja-dup/widgets/WidgetUtils.vala"
			_tmp7_ = g_build_filename (PKG_LIBEXEC_DIR, "deja-dup-monitor", NULL);
#line 75 "../deja-dup/widgets/WidgetUtils.vala"
			_g_free0 (monitor_exec);
#line 75 "../deja-dup/widgets/WidgetUtils.vala"
			monitor_exec = _tmp7_;
#line 358 "WidgetUtils.c"
		}
#line 78 "../deja-dup/widgets/WidgetUtils.vala"
		_tmp8_ = g_new0 (gchar*, 0 + 1);
#line 78 "../deja-dup/widgets/WidgetUtils.vala"
		_tmp9_ = _tmp8_;
#line 78 "../deja-dup/widgets/WidgetUtils.vala"
		_tmp9__length1 = 0;
#line 78 "../deja-dup/widgets/WidgetUtils.vala"
		_tmp10_ = monitor_exec;
#line 78 "../deja-dup/widgets/WidgetUtils.vala"
		deja_dup_run_deja_dup (_tmp9_, 0, _tmp10_);
#line 78 "../deja-dup/widgets/WidgetUtils.vala"
		_tmp9_ = (_vala_array_free (_tmp9_, _tmp9__length1, (GDestroyNotify) g_free), NULL);
#line 72 "../deja-dup/widgets/WidgetUtils.vala"
		_g_free0 (monitor_exec);
#line 374 "WidgetUtils.c"
	}
#line 82 "../deja-dup/widgets/WidgetUtils.vala"
	result = G_SOURCE_CONTINUE;
#line 82 "../deja-dup/widgets/WidgetUtils.vala"
	return result;
#line 380 "WidgetUtils.c"
}


gboolean
deja_dup_gui_initialize (GtkWindow* parent,
                         gboolean show_error)
{
	gboolean result = FALSE;
	gchar* header = NULL;
	gchar* msg = NULL;
	gboolean rv = FALSE;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 89 "../deja-dup/widgets/WidgetUtils.vala"
	_tmp2_ = deja_dup_initialize (&_tmp0_, &_tmp1_);
#line 89 "../deja-dup/widgets/WidgetUtils.vala"
	_g_free0 (header);
#line 89 "../deja-dup/widgets/WidgetUtils.vala"
	header = _tmp0_;
#line 89 "../deja-dup/widgets/WidgetUtils.vala"
	_g_free0 (msg);
#line 89 "../deja-dup/widgets/WidgetUtils.vala"
	msg = _tmp1_;
#line 89 "../deja-dup/widgets/WidgetUtils.vala"
	rv = _tmp2_;
#line 91 "../deja-dup/widgets/WidgetUtils.vala"
	_tmp3_ = rv;
#line 91 "../deja-dup/widgets/WidgetUtils.vala"
	if (_tmp3_) {
#line 412 "WidgetUtils.c"
		DejaDupFilteredSettings* settings = NULL;
		DejaDupFilteredSettings* _tmp4_;
		DejaDupFilteredSettings* _tmp5_;
		DejaDupFilteredSettings* _tmp6_;
		DejaDupFilteredSettings* _tmp7_;
#line 92 "../deja-dup/widgets/WidgetUtils.vala"
		_tmp4_ = deja_dup_get_settings (NULL);
#line 92 "../deja-dup/widgets/WidgetUtils.vala"
		settings = _tmp4_;
#line 93 "../deja-dup/widgets/WidgetUtils.vala"
		_tmp5_ = settings;
#line 93 "../deja-dup/widgets/WidgetUtils.vala"
		g_signal_connect (_tmp5_, "changed::" DEJA_DUP_PERIODIC_KEY, (GCallback) deja_dup_start_monitor_if_needed, NULL);
#line 94 "../deja-dup/widgets/WidgetUtils.vala"
		_tmp6_ = settings;
#line 94 "../deja-dup/widgets/WidgetUtils.vala"
		deja_dup_start_monitor_if_needed (_tmp6_);
#line 98 "../deja-dup/widgets/WidgetUtils.vala"
		_tmp7_ = settings;
#line 98 "../deja-dup/widgets/WidgetUtils.vala"
		g_object_ref ((GObject*) _tmp7_);
#line 91 "../deja-dup/widgets/WidgetUtils.vala"
		_g_object_unref0 (settings);
#line 436 "WidgetUtils.c"
	} else {
#line 100 "../deja-dup/widgets/WidgetUtils.vala"
		if (show_error) {
#line 440 "WidgetUtils.c"
			GtkMessageDialog* dlg = NULL;
			const gchar* _tmp8_;
			GtkMessageDialog* _tmp9_;
			GtkMessageDialog* _tmp10_;
			const gchar* _tmp11_;
			GtkMessageDialog* _tmp12_;
			GtkMessageDialog* _tmp13_;
#line 101 "../deja-dup/widgets/WidgetUtils.vala"
			_tmp8_ = header;
#line 101 "../deja-dup/widgets/WidgetUtils.vala"
			_tmp9_ = (GtkMessageDialog*) gtk_message_dialog_new (parent, GTK_DIALOG_DESTROY_WITH_PARENT | GTK_DIALOG_MODAL, GTK_MESSAGE_ERROR, GTK_BUTTONS_OK, "%s", _tmp8_);
#line 101 "../deja-dup/widgets/WidgetUtils.vala"
			g_object_ref_sink (_tmp9_);
#line 101 "../deja-dup/widgets/WidgetUtils.vala"
			dlg = _tmp9_;
#line 106 "../deja-dup/widgets/WidgetUtils.vala"
			_tmp10_ = dlg;
#line 106 "../deja-dup/widgets/WidgetUtils.vala"
			_tmp11_ = msg;
#line 106 "../deja-dup/widgets/WidgetUtils.vala"
			gtk_message_dialog_format_secondary_text (_tmp10_, "%s", _tmp11_);
#line 107 "../deja-dup/widgets/WidgetUtils.vala"
			_tmp12_ = dlg;
#line 107 "../deja-dup/widgets/WidgetUtils.vala"
			gtk_dialog_run ((GtkDialog*) _tmp12_);
#line 108 "../deja-dup/widgets/WidgetUtils.vala"
			_tmp13_ = dlg;
#line 108 "../deja-dup/widgets/WidgetUtils.vala"
			deja_dup_destroy_widget ((GtkWidget*) _tmp13_);
#line 100 "../deja-dup/widgets/WidgetUtils.vala"
			_g_object_unref0 (dlg);
#line 472 "WidgetUtils.c"
		}
	}
#line 111 "../deja-dup/widgets/WidgetUtils.vala"
	result = rv;
#line 111 "../deja-dup/widgets/WidgetUtils.vala"
	_g_free0 (msg);
#line 111 "../deja-dup/widgets/WidgetUtils.vala"
	_g_free0 (header);
#line 111 "../deja-dup/widgets/WidgetUtils.vala"
	return result;
#line 483 "WidgetUtils.c"
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



